package real;

import io.Message;
import java.io.IOException;
import java.util.ArrayList;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.JSONValue;
import server.util;

/**
 *
 * @author Văn Tú
 */
public class ItemData {

    public short id;
    public byte type;
    public byte nclass;
    public byte skill;
    public byte gender;
    public String name;
    public String description;
    public byte level;
    public short iconID;
    public short part;
    public boolean uptoup;
    public boolean isExpires;
    public long seconds_expires;
    public int saleCoinLock;
    public ArrayList<Option> itemoption;
    public static ArrayList<ItemData> entrys = new ArrayList<>();
    private static final int[] arrOp = new int[]{6, 7, 10, 67, 68, 69, 70, 71, 72, 73, 74};
    private static final int[] arrParam = new int[]{50, 50, 10, 5, 10, 10, 5, 5, 5, 100, 50};
    private static final byte[] arrOpenBag = new byte[]{0,6,6,12};
    
    public static boolean isTypeBody(int id) {
        for (ItemData entry : entrys) {
            if (entry.id == id) {
                return entry.type >= 0 && entry.type <= 15;
            }
        }
        return false;
    }

    public static boolean isTypeUIME(int typeUI) {
        return typeUI == 5 || typeUI == 3 || typeUI == 4 || typeUI == 39;
    }

    public static boolean isTypeUIShop(int typeUI) {
        return typeUI == 20 || typeUI == 21 || typeUI == 22 || typeUI == 23 || typeUI == 24 || typeUI == 25 || typeUI == 26 || typeUI == 27 || typeUI == 28 || typeUI == 29 || typeUI == 16 || typeUI == 17 || typeUI == 18 || typeUI == 19 || typeUI == 2 || typeUI == 6 || typeUI == 8 || typeUI == 34;
    }

    public static boolean isTypeUIShopLock(int typeUI) {
        return typeUI == 7 || typeUI == 9;
    }

    public static boolean isTypeUIStore(int typeUI) {
        return typeUI == 14;
    }

    public static boolean isTypeUIBook(int typeUI) {
        return typeUI == 15;
    }

    public static boolean isTypeUIFashion(int typeUI) {
        return typeUI == 32;
    }

    public static boolean isTypeUIClanShop(int typeUI) {
        return typeUI == 34;
    }

    public static boolean isTypeMounts(int id) {
        for (ItemData entry : entrys) {
            if (entry.id == id) {
                return entry.type >= 29 && entry.type <= 33;
            }
        }
        return false;
    }

    public static boolean isTypeNgocKham(int id) {
        for (ItemData entry : entrys) {
            if (entry.id == id) {
                return entry.type == 34;
            }
        }
        return false;
    }
    
    public static int upgradeParam(int id) {
        switch (id) {
            case 6:
            case 7:
                return 15;
            case 9:
            case 10:
            case 11:
            case 13:
            case 14:
            case 15:
            case 17:
            case 18:
                return 5;
            case 16:
                return 3;
            case 19:
            case 20:
                return 10;
            case 21:
            case 22:
            case 23:
            case 24:
            case 25:
            case 26:
                return 150;
        }
        return 0;
    }
    
    public static int minParam(int id, int param) {
        switch (id) {
            case 0:
            case 1:
                return param-49;
            case 2:
            case 3:
            case 4:
            case 5:
            case 10:
            case 11:
            case 12:
            case 13:
            case 14:
                return param-4;
            case 6:
            case 7:
            case 8:
            case 9:
                return param-9;
        }
        return param;
    }

    public static void divedeItem(Player p, Message m) throws IOException {
        byte index = m.reader().readByte();
        int quantity = m.reader().readInt();
        m.cleanup();
        if (p.nj.getBagNull() == 0) {
            p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
            return;
        }
        Item item = p.nj.getIndexBag(index);
        if (quantity > 0 && item != null && item.quantity > 1 && quantity <= item.quantity) {
            Item itemup = new Item();
            itemup.id = item.id;
            itemup.isLock = item.isLock;
            itemup.upgrade = item.upgrade;
            itemup.isExpires = item.isExpires;
            itemup.quantity = quantity;
            itemup.expires = item.expires;
            p.nj.addItemBag(false, itemup);
            p.nj.removeItemBag(index, quantity);
        }
    }

    public static void uesItem(Player p, Item item, byte index) throws IOException {
        if (ItemDataId(item.id).level > p.nj.level) {
            return;
        }
        ItemData data = ItemDataId(item.id);
        if (data.gender != 2 && data.gender != p.nj.gender) {
            return;
        }
        if (data.type == 26) {
            p.sendAddchatYellow("Vật phẩm liên quan đến nâng cấp, hãy gặp Kenshinto trong làng để sử dụng.");
            return;
        } else if ((item.id == 547 && p.nj.nclass == 0) || (data.nclass > 0 && data.nclass != p.nj.nclass)) {
            p.sendAddchatYellow("Môn phái không phù hợp");
            return;
        } else if (isTypeBody(item.id)) {
            item.isLock = true;
            p.nj.ItemBag[index] = p.nj.ItemBody[data.type];
            p.nj.ItemBody[data.type] = item;
        } else if (isTypeMounts(item.id)) {
            byte idM = (byte) (data.type - 29);
            if (idM == 4) {
                if (!item.isLock) {
                    for (byte i = 0; i < 4; i++) {
                        int op = -1;
                        while (true) {
                            op = util.nextInt(arrOp.length);
                            for (Option option : item.option) {
                                if (arrOp[op] == option.id) {
                                    op = -1;
                                    break;
                                }
                            }
                            if (op != -1) {
                                break;
                            }
                        }
                        byte sys = -1;
                        int idOp = arrOp[op];
                        int par = arrParam[op];
                        if (item.id == 523 || item.id == 524 || item.id == 485 || item.id == 443) {
                            byte cs = (byte) util.nextInt(5,15);
                            par *= cs+sys;
                         }
                        Option option = new Option(idOp, par);
                        item.option.add(option);
                        switch(util.nextInt(3)) {
                        case 0: 
                        sys = (byte) util.nextInt(1, 4);
                        item.sys = sys;
                        }
                    }
                }
            }
            item.isLock = true;
            p.nj.ItemBag[index] = p.nj.ItemMounts[idM];
            p.nj.ItemMounts[idM] = item;
        }
        if (data.skill > 0) {
            byte skill = data.skill;
            if (item.id == 547) {
                skill += p.nj.nclass;
            }
            p.openBookSkill(index, skill);
            return;
        }
        byte numbagnull = p.nj.getBagNull();
        Item itemup;
        switch (item.id) {
            case 215:
            case 229:
            case 283: {
                byte level = (byte) ((item.id!=215)?(item.id!=229)?3:2:1);
                if (level>p.nj.levelBag+1) {
                    p.sendAddchatYellow("Cần mở Túi vải cấp "+(p.nj.levelBag+1)+" mới có thể mở được túi vải này");
                    return;
                }
                if (p.nj.levelBag >= level) {
                    p.sendAddchatYellow("Bạn đã mở túi vải này rồi");
                    return;
                }
                p.nj.levelBag = level;
                p.nj.maxluggage += arrOpenBag[level];
                Item[] bag = new Item[p.nj.maxluggage];
                for (short i = 0; i < p.nj.ItemBag.length; i++) {
                    bag[i] = p.nj.ItemBag[i];
                }
                p.nj.ItemBag = bag;
                p.nj.ItemBag[index] = null;
                p.openBagLevel(index);
            }
            break;
            case 383:
            case 384:
            case 647:   
            case 385: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                if (p.nj.nclass == 0) {
                    p.conn.sendMessageLog("Hãy nhập học để mở vật phẩm.");
                    return;
                }
                int idI;
                byte sys = -1;
                if (util.nextInt(2) == 0) {
                    if (p.nj.gender == 0) {
                        if (p.nj.level < 50 && item.id != 384 && item.id != 385 && item.id != 647) {
                            idI = new short[]{171, 161, 151, 141, 131}[util.nextInt(5)];
                        } else if (p.nj.level < 60 && item.id != 385 && item.id != 384 && item.id != 647) {
                            idI = new short[]{137, 163, 153, 143, 133}[util.nextInt(5)];
                        } else if (p.nj.level < 70) {
                            idI = new short[]{332, 329, 328, 327, 326}[util.nextInt(5)];
                        } else {
                            idI = new short[]{368, 367, 366, 365, 364, 493, 495, 497, 499, 501, 619, 621, 623, 625, 627, 715, 716}[util.nextInt(17)];
                        }
                    } else {
                        if (p.nj.level < 50 && item.id != 384 && item.id != 385 && item.id != 647) {
                            idI = new short[]{170, 160, 150, 140, 130}[util.nextInt(5)];
                        } else if (p.nj.level < 60 && item.id != 385 && item.id != 384 && item.id != 647) {
                            idI = new short[]{172, 162, 152, 142, 132}[util.nextInt(5)];
                        } else if (p.nj.level < 70) {
                            idI = new short[]{325, 323, 321, 319, 317}[util.nextInt(5)];
                        } else {
                            idI = new short[]{363, 361, 359, 357, 355, 492, 494, 496, 498, 500, 618, 620, 622, 624, 626, 712, 713}[util.nextInt(17)];
                        }
                    }
                } else {
                    if (util.nextInt(2) == 1) {
                        if (p.nj.nclass == 1 || p.nj.nclass == 2) {
                            sys = 1;
                        } else if (p.nj.nclass == 3 || p.nj.nclass == 4) {
                            sys = 2;
                        } else if (p.nj.nclass == 5 || p.nj.nclass == 6) {
                            sys = 3;
                        }
                        if (p.nj.level < 50 && item.id != 384 && item.id != 385 && item.id != 647) {
                            idI = new short[]{97, 117, 102, 112, 107, 122}[p.nj.nclass - 1];
                        } else if (p.nj.level < 60 && item.id != 385 && item.id != 384 && item.id != 647) {
                            idI = new short[]{98, 118, 103, 113, 108, 123}[p.nj.nclass - 1];
                        } else if (p.nj.level < 80) { 
                            idI = new short[]{506, 507, 508, 509, 510, 511}[p.nj.nclass - 1];
                        } else if (p.nj.level < 90) { 
                            idI = new short[]{632, 633, 634, 635, 636, 637}[p.nj.nclass - 1];
                        } else if (p.nj.level < 70) {
                            idI = new short[]{331, 332, 333, 334, 335, 336}[p.nj.nclass - 1];
                        } else {
                            idI = new short[]{369, 370, 371, 372, 373, 374}[p.nj.nclass - 1];
                        }
                    } else {
                        if (p.nj.level < 50 && item.id != 384 && item.id != 647) {
                            idI = new short[]{192, 187, 182, 177}[util.nextInt(4)];
                        } else if (p.nj.level < 60 && item.id != 385 && item.id != 384 && item.id != 647) {
                            idI = new short[]{193, 188, 183, 178}[util.nextInt(4)];
                        } else if (p.nj.level < 70) {
                            idI = new short[]{324, 322, 320, 318}[util.nextInt(4)];
                        }  else {
                            idI = new short[]{362, 360, 358, 356, 502, 503, 504, 505, 628, 629, 630, 631}[util.nextInt(12)];
                        }
                    }
                }
                if (sys < 0) {
                    sys = (byte) util.nextInt(1, 3);
                    itemup = ItemData.itemDefault(idI, sys);
                } else 
                    itemup = ItemData.itemDefault(idI);
                itemup.sys = sys;
                if (ItemData.ItemDataId(itemup.id).type == 1) {
                    itemup.option.add(new Option((byte)6, 500));
                    itemup.option.add(new Option(7, 500));
                    itemup.option.add(new Option(73, 1000));
                } else {
                    itemup.option.add(new Option((byte)6, 500));
                    itemup.option.add(new Option(7, 500));
                }
                    
                itemup.upgrade = 12;
                if (item.id == 384) {
                    itemup.option.clear();
                    itemup.upgrade = 14;
                    if (ItemData.ItemDataId(itemup.id).type == 1) {
                        itemup.option.add(new Option((byte)6, 1500));
                        itemup.option.add(new Option(7, 1500));
                        itemup.option.add(new Option(73, 2000));
                    } else {
                        itemup.option.add(new Option((byte)6, 1500));
                        itemup.option.add(new Option(7, 1500));
                    }
                } else if (item.id == 385) {
                    itemup.upgrade = 16;
                     itemup.option.clear();
                      if (ItemData.ItemDataId(itemup.id).type == 1) {
                        itemup.option.add(new Option((byte)6, 2500));
                        itemup.option.add(new Option(7, 2500));
                        itemup.option.add(new Option(73, 3000));
                    } else {
                        itemup.option.add(new Option((byte)6, 2500));
                        itemup.option.add(new Option(7, 2500));
                      }
                } else if (item.id == 647) {
                    byte cs2 = (byte) util.nextInt(1,16);
                     itemup.upgrade = cs2;
                     itemup.option.clear();
                     short cs = (short) util.nextInt(100,600);
                     short cs1 = (short) util.nextInt(10,80);
                     short cs3 = (short) util.nextInt(1,20);
                      if (ItemData.ItemDataId(itemup.id).type == 1) {
                        itemup.option.add(new Option((byte)6, cs*cs2));
                        itemup.option.add(new Option(7, cs*cs2));
                        itemup.option.add(new Option(73, cs1*cs2));
                        itemup.option.add(new Option(115, cs3));
                        itemup.option.add(new Option(116, cs3));
                        itemup.option.add(new Option(114, cs3));
                    } else {
                         itemup.option.add(new Option((byte)6, cs*cs2));
                        itemup.option.add(new Option(7, cs*cs2));
                        itemup.option.add(new Option(115, cs3));
                        itemup.option.add(new Option(116, cs3));
                        itemup.option.add(new Option(114, cs3));
                      }
                } 
                itemup.isLock = item.isLock;
                p.nj.addItemBag(true, itemup);
                p.nj.removeItemBag(index, 1);
            }
            break;
            case 381: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                p.updateExp(10000000L);
                if (util.nextInt(7) == 0) {
                    p.updateExp(20000000L);
                }
                 p.nj.removeItemBag(index, 1);
            }
            case 478: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                short[] arId = new short[]{94,95,96,99,100,101,104,105,106,109,110,111,114,115,119,120,121,124,125,126,127,128,129,134,135,136,137,138,139,144,145,146,147,148,149,154,155,156,157,158,159,164,165,166,167,168,169,174,175,176,179,180,181,184,185,186,189,190,191,194};
                     short idI = arId[util.nextInt(arId.length)];
                   itemup = ItemData.itemDefault(idI);
                     byte cs2 = (byte) util.nextInt(1,16);
                     itemup.upgrade = cs2;
                     itemup.option.clear();
                     short cs = (short) util.nextInt(100,400);
                     short cs1 = (short) util.nextInt(10,50);
                     short cs3 = (short) util.nextInt(10,60);
                         itemup.option.add(new Option((byte)6, cs*cs2));
                        itemup.option.add(new Option(7, cs*cs2));
                        itemup.option.add(new Option(73, cs1*cs2));
                        itemup.option.add(new Option(115, cs3));
                        itemup.option.add(new Option(116, cs3));
                        itemup.option.add(new Option(114, cs3));
                        itemup.isLock = item.isLock;
                        p.nj.addItemBag(true, itemup);  
                   p.nj.removeItemBag(index, 1);
            }
            break;
            case 476: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                short[] arId = new short[]{419,569,586,589,742,397,398,399,400,401,402,423,424,425,426,427};
                    short idI = arId[util.nextInt(arId.length)];
                   itemup = ItemData.itemDefault(idI);
                     byte cs2 = (byte) util.nextInt(1,16);
                     itemup.upgrade = cs2;
                     itemup.option.clear();
                     short cs = (short) util.nextInt(100,400);
                     short cs1 = (short) util.nextInt(10,50);
                     short cs3 = (short) util.nextInt(10,60);
                     
                         itemup.option.add(new Option((byte)6, cs*cs2));
                        itemup.option.add(new Option(7, cs*cs2));
                        itemup.option.add(new Option(73, cs1*cs2));
                         itemup.option.add(new Option(115, cs3));
                        itemup.option.add(new Option(116, cs3));
                        itemup.option.add(new Option(114, cs3));
                        itemup.isLock = item.isLock;
                        p.nj.addItemBag(true, itemup);  
                   p.nj.removeItemBag(index, 1);
            }
            break;
            case 612: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                short[] arId = new short[]{685,686,687,688,689,690,691,692,693,694,689,420,421,422};
                    short idI = arId[util.nextInt(arId.length)];
                   itemup = ItemData.itemDefault(idI);
                     byte cs2 = (byte) util.nextInt(1,16);
                     itemup.upgrade = cs2;
                     itemup.option.clear();
                     short cs = (short) util.nextInt(100,400);
                     short cs1 = (short) util.nextInt(10,50);
                     short cs3 = (short) util.nextInt(1,50);
                     itemup.option.add(new Option((byte)6, cs*cs2));
                        itemup.option.add(new Option(7, cs*cs2));
                        itemup.option.add(new Option(73, cs1*cs2));
                        itemup.option.add(new Option(115, cs3));
                        itemup.option.add(new Option(116, cs3));
                        itemup.option.add(new Option(114, cs3));
                        itemup.isLock = item.isLock;
                        p.nj.addItemBag(true, itemup);  
                   p.nj.removeItemBag(index, 1);
            }
            break;
            case 535: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                short[] arId = new short[]{486,487,488,489,439,440,441,442};
                    short idI = arId[util.nextInt(arId.length)];
                     itemup = ItemData.itemDefault(idI);
                     itemup.option.clear();
                     short cs = (short) util.nextInt(10,2000);
                     short cs1 = (short) util.nextInt(10,500);
                     short cs3 = (short) util.nextInt(1,50);
                     
                        itemup.option.add(new Option((byte)6, cs));
                        itemup.option.add(new Option(7, cs));
                        itemup.option.add(new Option(73, cs1));
                         itemup.option.add(new Option(115, cs3));
                        itemup.option.add(new Option(116, cs3));
                        itemup.option.add(new Option(114, cs3));
                        itemup.isLock = item.isLock;
                        p.nj.addItemBag(true, itemup);  
                   p.nj.removeItemBag(index, 1);
            }
            break;
            case 645: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                short[] arId = new short[]{774,771,711,714,745,616,615,614,613,594,542,541,408,407,403,404,351,352,353,354,337,338};
                    short idI = arId[util.nextInt(arId.length)];
                   itemup = ItemData.itemDefault(idI);
                     byte cs2 = (byte) util.nextInt(1,16);
                     itemup.upgrade = cs2;
                     itemup.option.clear();
                     short cs = (short) util.nextInt(100,400);
                     short cs1 = (short) util.nextInt(10,50);
                      short cs3 = (short) util.nextInt(1,50);
                     
                        itemup.option.add(new Option((byte)6, cs*cs2));
                        itemup.option.add(new Option(7, 4000*cs2));
                        itemup.option.add(new Option(73, cs1*cs2));
                        itemup.option.add(new Option(5, cs3));
                        itemup.isLock = item.isLock;
                        p.nj.addItemBag(true, itemup);  
                   p.nj.removeItemBag(index, 1);
            }
            break;
            case 382: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                p.updateExp(20000000L);
                if (util.nextInt(7) == 0) {
                    p.updateExp(25000000L);
                }
                 p.nj.removeItemBag(index, 1);
            }
            case 434: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                p.updateExp(20000000L);
                if (util.nextInt(7) == 0) {
                    p.updateExp(25000000L);
                } else {
                    short[] arId = new short[]{4,4,476,4,5,5,476,5,6,647,6,275,276,277,278, 289, 383, 397, 398, 399, 647, 401, 402, 407, 647, 409, 410, 443, 454, 485, 524, 549, 550, 551, 568, 569, 570, 571, 577};
                    short idI = arId[util.nextInt(arId.length)];
                    itemup = itemDefault(idI);
                    itemup.isLock = item.isLock;
                    p.nj.addItemBag(true, itemup);
                }
                p.nj.removeItemBag(index, 1);
            }
            break;
            
            case 435: {
                if (numbagnull == 0) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return;
                }
                p.updateExp(30000000L);
                if (util.nextInt(5) == 0) {
                    p.updateExp(35000000L);
                } else {
                    short[] arId = new short[]{4,4,476,4,5,5,476,5,6,6,647,7,7,8,9,10,275, 276, 277, 278, 289, 385, 397, 398, 647, 400, 401, 647, 407, 408, 409, 410, 443, 454, 485, 524, 549, 550, 551, 568, 569, 570, 571, 577};
                    short idI = arId[util.nextInt(arId.length)];
                    itemup = itemDefault(idI);
                    itemup.isLock = item.isLock;
                    p.nj.addItemBag(true, itemup);
                }
                p.nj.removeItemBag(index, 1);
            }
            break;
        }
        Message m = new Message(11);
        m.writer().writeByte(index);//vi tri item
        m.writer().writeByte(p.nj.speed());//toc do
        m.writer().writeInt(p.nj.getMaxHP());//hp max
        m.writer().writeInt(p.nj.getMaxMP());//mp max
        m.writer().writeShort(p.nj.eff5buffHP());//eff5BuffHp
        m.writer().writeShort(p.nj.eff5buffMP());//eff5BuffMp
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
        if (isTypeMounts(item.id)) {
            for (Player player : p.nj.place.players) {
                p.nj.place.sendMounts(p, player);
            }
        }
    }
    
    public static boolean isUpgradeHide(int id,byte upgrade) {
        if ((id == 27 || id == 30 || id == 60) && upgrade < 4)
            return true;
        else if ((id == 28 || id == 31 || id == 37 || id == 61) && upgrade < 8)
            return true;
        else if ((id == 29 || id == 32 || id == 38 || id == 62) && upgrade < 12)
            return true;
        else if ((id == 33 || id == 34 || id == 35 || id == 36 || id == 39) && upgrade < 14)
            return true;
        else if (((id >= 40 && id <= 46) || (id >= 48 && id <= 56)) && upgrade < 16)
            return true;
        return false;
    }
    
     public static Item itemDefault(int id) {
         return itemDefault(id, (byte)0);
     }

    public static Item itemDefault(int id,byte sys) {
        Item item = new Item();
        item.id = (short) id;
        item.sys = sys;
        ItemData data = ItemDataId(id);
        if (data.isExpires) {
            item.isExpires = true;
            item.expires = util.TimeSeconds(data.seconds_expires);
        }
        item.saleCoinLock = data.saleCoinLock;
       
        for (Option option : data.itemoption) {
            int idOp = option.id;
            int par = option.param;
            Option op = new Option(idOp, par);
            item.option.add(op);
        }
        return item;
    }

    public static Item parseItem(String str) {
        Item item = new Item();
        JSONObject job = (JSONObject) JSONValue.parse(str);
        item.id = Short.parseShort(job.get("id").toString());
        item.isLock = Boolean.parseBoolean(job.get("isLock").toString());
        item.upgrade = Byte.parseByte(job.get("upgrade").toString());
        item.isExpires = Boolean.parseBoolean(job.get("isExpires").toString());
        item.quantity = Integer.parseInt(job.get("quantity").toString());
        if (item.isExpires) {
            item.expires = Long.parseLong(job.get("expires").toString());
        }
        item.sys = Byte.parseByte(job.get("sys").toString());
        item.saleCoinLock = Integer.parseInt(job.get("sale").toString());
        JSONArray Option = (JSONArray) JSONValue.parse(job.get("option").toString());
        for (Object Option1 : Option) {
            JSONObject job2 = (JSONObject) Option1;
            Option option = new Option(Integer.parseInt(job2.get("id").toString()), Integer.parseInt(job2.get("param").toString()));
            item.option.add(option);
        }
        return item;
    }

    public static JSONObject ObjectItem(Item item, int index) {
        JSONObject put = new JSONObject();
        put.put("index", index);
        put.put("id", item.id);
        put.put("isLock", item.isLock);
        put.put("upgrade", item.upgrade);
        put.put("isExpires", item.isExpires);
        put.put("quantity", item.quantity);
        if (item.isExpires) {
            put.put("expires", item.expires);
        }
        put.put("sys", item.sys);
        put.put("sale", item.saleCoinLock);
        JSONArray option = new JSONArray();
        for (Option Option : item.option) {
            JSONObject pa = new JSONObject();
            pa.put("id", Option.id);
            pa.put("param", Option.param);
            option.add(pa);
        }
        put.put("option", option);
        return put;
    }

    public static ItemData ItemDataId(int id) {
        for (ItemData entry : entrys) {
            if (entry.id == id) {
                return entry;
            }
        }
        return null;
    }
}
