package real;

import boardGame.Place;

/**
 *
 * @author Văn Tú
 */
public class Map extends Thread {

    public byte id;
    public byte tile;
    public byte backid;
    public String name;
    public byte type;
    public Place[] area;
    public byte maxplayers;
    public Vgo[] vgo;
    public Npc[] npc;
    public short x0;
    public short y0;
    private boolean runing;

    public Map(byte id, byte tile, byte backid, String name, byte type, byte maxplayers, byte numarea, short x0, short y0) {
        this.id = id;
        this.tile = tile;
        this.backid = backid;
        this.name = name;
        this.type = type;
        this.maxplayers = maxplayers;
        this.area = new Place[numarea];
        for (byte i = 0; i < numarea; i++) {
            area[i] = new Place(this, i);
        }
        this.x0 = x0;
        this.y0 = y0;
        this.runing = true;
        this.start();
    }

    private void update() {
        for (byte i = 0; i < area.length; i++) {
            area[i].update();
        }
    }

    @Override
    public void run() {
        while (runing) {
            long l1 = System.currentTimeMillis();
            update();
            long l2 = System.currentTimeMillis() - l1;
            if (l2 < 500) {
                try {
                    Thread.sleep(500 - l2);
                } catch (InterruptedException e) {
                }
            }
        }
    }

    public void close() {
        runing = false;
        name = null;
        for (byte i = 0; i < area.length; i++) {
            area[i].close();
            area[i] = null;
        }
        area = null;
        if (vgo != null) {
            for (byte i = 0; i < vgo.length; i++) {
                vgo[i] = null;
            }
            vgo = null;
        }
    }
}
