package real;

import boardGame.Place;
import server.SQLManager;
import io.Message;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.JSONValue;

/**
 *
 * @author Văn Tú
 */
public class Ninja extends Body {

    public Player p = null;
    public int id = 0;
    public Place place = null;
    public String name = null;
    public String clanName = "";
    public byte typeclan = 0;
    public byte taskId = 0;
    public byte gender = -1;
    public byte head = -1;
    public ArrayList<Skill> skill = new ArrayList<>();
    public int xu = 0;
    public int xuBox = 0;
    public int yen = 0;
    protected byte maxluggage = 30;
    protected byte levelBag = 0;
    public Item[] ItemBag = null;
    public Item[] ItemBox = null;
    public Item[] ItemBody = null;
    public Item[] ItemMounts = null;
    protected String friend = "[]";
    public int mapLTD = 22;
    public byte map = 22;
    public int eff5buff = 0;
    public byte type = 0;

    private Ninja() {
        super.seNinja(this);
    }

    public short partHead() {
        if (ItemBody[11] != null) {
            return ItemData.ItemDataId(ItemBody[11].id).part;
        }
        return head;
    }

    public short Weapon() {
        if (ItemBody[1] != null) {
            return ItemData.ItemDataId(ItemBody[1].id).part;
        }
        return -1;
    }

    public short Body() {
        if (ItemBody[2] != null) {
            return ItemData.ItemDataId(ItemBody[2].id).part;
        }
        return -1;
    }

    public short Leg() {
        if (ItemBody[6] != null) {
            return ItemData.ItemDataId(ItemBody[6].id).part;
        }
        return -1;
    }

    public Skill getSkill(int id) {
        for (Skill skl : skill) {
            if (skl.id == id) {
                return skl;
            }
        }
        return null;
    }
    
    
    public void setLevel_Exp(long exp, boolean value) {
        long[] levelExp = Level.getLevelExp(exp);
        if (value) {
            level = (int) levelExp[0];
        }
        expr = levelExp[1];
    }

    public byte getBagNull() {
        byte num = 0;
        for (byte i = 0; i < ItemBag.length; i++) {
            if (ItemBag[i] == null) {
                num++;
            }
        }
        return num;
    }

    public byte getBoxNull() {
        byte num = 0;
        for (byte i = 0; i < ItemBox.length; i++) {
            if (ItemBox[i] == null) {
                num++;
            }
        }
        return num;
    }

    public Item getIndexBag(int index) {
        if (index < ItemBag.length && index >= 0) {
            return ItemBag[index];
        }
        return null;
    }

    public Item getIndexBox(int index) {
        if (index < ItemBox.length && index >= 0) {
            return ItemBox[index];
        }
        return null;
    }

    public int quantityItemyTotal(int id) {
        int quantity = 0;
        for (byte i = 0; i < ItemBag.length; i++) {
            Item item = ItemBag[i];
            if (item == null || item.id != id) {
                continue;
            }
            quantity += item.quantity;
        }
        return quantity;
    }

    protected Item getItemIdBag(int id) {
        for (byte i = 0; i < ItemBag.length; i++) {
            Item item = ItemBag[i];
            if (item == null || item.id != id) {
                continue;
            }
            return item;
        }
        return null;
    }

    public byte getIndexBagid(int id, boolean lock) {
        for (byte i = 0; i < ItemBag.length; i++) {
            Item item = ItemBag[i];
            if (item == null || item.id != id || item.isLock != lock) {
                continue;
            }
            return i;
        }
        return -1;
    }

    public byte getIndexBoxid(int id, boolean lock) {
        for (byte i = 0; i < ItemBox.length; i++) {
            Item item = ItemBox[i];
            if (item == null || item.id != id || item.isLock != lock) {
                continue;
            }
            return i;
        }
        return -1;
    }

    protected byte getIndexBagItem(int id, boolean lock) {
        for (byte i = 0; i < ItemBag.length; i++) {
            Item item = ItemBag[i];
            if (item == null || item.id != id || item.isLock != lock) {
                continue;
            }
            return i;
        }
        return -1;
    }

    public byte getIndexBagNotItem() {
        for (byte i = 0; i < ItemBag.length; i++) {
            Item item = ItemBag[i];
            if (item == null) {
                return i;
            }
        }
        return -1;
    }

    protected byte getIndexBoxNotItem() {
        for (byte i = 0; i < ItemBox.length; i++) {
            Item item = ItemBox[i];
            if (item == null) {
                return i;
            }
        }
        return -1;
    }

    protected void setXPLoadSkill(long exp) throws IOException {
        this.exp = exp;
        Message m = new Message(-30);
        m.writer().writeByte(-124);
        m.writer().writeByte(speed);
        m.writer().writeInt(getMaxHP());
        m.writer().writeInt(getMaxMP());
        m.writer().writeLong(exp);
        m.writer().writeShort(spoint);
        m.writer().writeShort(ppoint);
        m.writer().writeShort(potential0);
       m.writer().writeShort(potential1);
        m.writer().writeInt(potential2);
        m.writer().writeInt(potential3);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
    
    protected void sortBag() throws IOException {
        //Gop item lai
        for (byte i = 0; i < ItemBag.length; i++) {
            if (ItemBag[i] != null && !ItemBag[i].isExpires && ItemData.ItemDataId(ItemBag[i].id).uptoup) {
                for (byte j = (byte) (i + 1); j < ItemBag.length; j++) {
                    if (ItemBag[j] != null && !ItemBag[i].isExpires && ItemBag[j].id == ItemBag[i].id && ItemBag[j].isLock == ItemBag[i].isLock) {
                        ItemBag[i].quantity += ItemBag[j].quantity;
                        ItemBag[j] = null;
                    }
                }
            }
        }
        //Day item len
        for (byte i = 0; i < ItemBag.length; i++) {
            if (ItemBag[i] == null) {
                for (byte j = (byte) (i + 1); j < ItemBag.length; j++) {
                    if (ItemBag[j] != null) {
                        ItemBag[i] = ItemBag[j];
                        ItemBag[j] = null;
                        break;
                    }
                }
            }
        }
        Message m = new Message(-30);
        m.writer().writeByte(-107);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }

    protected void sortBox() throws IOException {
        //Gop item lai
        for (byte i = 0; i < ItemBox.length; i++) {
            if (ItemBox[i] != null && !ItemBox[i].isExpires && ItemData.ItemDataId(ItemBox[i].id).uptoup) {
                for (byte j = (byte) (i + 1); j < ItemBox.length; j++) {
                    if (ItemBox[j] != null && !ItemBox[i].isExpires && ItemBox[j].id == ItemBox[i].id && ItemBox[j].isLock == ItemBox[i].isLock) {
                        ItemBox[i].quantity += ItemBox[j].quantity;
                        ItemBox[j] = null;
                    }
                }
            }
        }
        //Day item len
        for (byte i = 0; i < ItemBox.length; i++) {
            if (ItemBox[i] == null) {
                for (byte j = (byte) (i + 1); j < ItemBox.length; j++) {
                    if (ItemBox[j] != null) {
                        ItemBox[i] = ItemBox[j];
                        ItemBox[j] = null;
                        break;
                    }
                }
            }
        }
        Message m = new Message(-30);
        m.writer().writeByte(-106);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }

    public boolean addItemBag(Boolean uptoup, Item itemup) {
        try {
            byte index = getIndexBagid(itemup.id, itemup.isLock);
            if (uptoup && !itemup.isExpires && ItemData.ItemDataId(itemup.id).uptoup && index != -1) {
                ItemBag[index].quantity += itemup.quantity;
                Message m = new Message(9);
                m.writer().writeByte(index);//vi tri
                m.writer().writeShort(itemup.quantity);//solong
                m.writer().flush();
                p.conn.sendMessage(m);
                m.cleanup();
                return true;
            } else {
                index = getIndexBagNotItem();
                if (index == -1) {
                    p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
                    return false;
                }
                ItemBag[index] = itemup;
                Message m = new Message(8);
                m.writer().writeByte(index);//vi tri
                m.writer().writeShort(itemup.id);//id
                m.writer().writeBoolean(itemup.isLock);//khoa hay ko
                if (ItemData.isTypeBody(itemup.id) || ItemData.isTypeNgocKham(itemup.id)) {
                    m.writer().writeByte(itemup.upgrade);//trang bi +
                }
                m.writer().writeBoolean(itemup.isExpires);//han su dung
                m.writer().writeShort(itemup.quantity);//number
                m.writer().flush();
                p.conn.sendMessage(m);
                return true;
            }
        } catch (IOException ex) {
        }
        return false;
    }

    public void removeItemBags(int id, int quantity) {
        int num = 0;
        for (byte i = 0; i < ItemBag.length; i++) {
            Item item = ItemBag[i];
            if (item == null || item.id != id) {
                continue;
            }
            if (num + item.quantity >= quantity) {
                removeItemBag(i, quantity - num);
                break;
            } else {
                num += quantity;
                removeItemBag(i, item.quantity);
            }
        }
    }

    public void removeItemBag(byte index, int quantity) {
        Item item = getIndexBag(index);
        try {
            item.quantity -= quantity;
            Message m = new Message(18);
            m.writer().writeByte(index);//vi tri item
            m.writer().writeShort(quantity);//- number item
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
            if (item.quantity <= 0) {
                ItemBag[index] = null;
            }
        } catch (IOException ex) {
        }
    }
    
    public void removeItemBody(byte index) throws IOException {
        ItemBody[index] = null;
        Message m = new Message(-30);
        m.writer().writeByte(-80);
        m.writer().writeByte(index);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }

    public void removeItemBox(byte index) throws IOException {
        ItemBag[index] = null;
        Message m = new Message(-30);
        m.writer().writeByte(-75);
        m.writer().writeByte(index);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }

    public synchronized int upxu(long x) {
        long xunew = (long) xu + x;
        if (xunew > 2000000000) {
            x = 2000000000 - xu;
        } else if (xunew < -2000000000) {
            x = -2000000000 - xu;
        }
        xu += x;
        return (int) x;
    }

    public synchronized int upyen(long x) {
        long yennew = (long) yen + x;
        if (yennew > 2000000000) {
            x = 2000000000 - yen;
        } else if (yennew < -2000000000) {
            x = -2000000000 - yen;
        }
        yen += x;
        return (int) x;
    }

    public void upxuMessage(long x) {
        try {
            Message m = new Message(95);
            m.writer().writeInt(upxu(x));
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
        } catch (IOException ex) {
        }
    }

    public void upyenMessage(long x) {
        try {
            Message m = new Message(-8);
            m.writer().writeInt(upyen(x));
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
        } catch (IOException ex) {
        }
    }

    protected static Ninja setup(Player p, String name) {
        ResultSet red;
        try {
            red = SQLManager.stat.executeQuery("SELECT * FROM `ninja` WHERE `name`=\"" + name + "\" LIMIT 1;");
            red.first();
            Ninja nja = new Ninja();
            nja.p = p;
            nja.id = red.getInt("id");
            nja.name = red.getString("name");
            nja.gender = red.getByte("gender");
            nja.head = red.getByte("head");
            nja.speed = red.getByte("speed");
            nja.nclass = red.getByte("class");
            nja.ppoint = red.getShort("ppoint");
            nja.potential0 = red.getShort("potential0");
            nja.potential1 = red.getShort("potential1");
            nja.potential2 = red.getInt("potential2");
            nja.potential3 = red.getInt("potential3");
            nja.spoint = red.getShort("spoint");
            JSONArray jar = (JSONArray) JSONValue.parse(red.getString("skill"));
            if (jar != null) {
                for (byte j = 0; j < jar.size(); j++) {
                    JSONObject job = (JSONObject) jar.get(j);
                    Skill skill = new Skill();
                    skill.id = Byte.parseByte(job.get("id").toString());
                    skill.point = Byte.parseByte(job.get("point").toString());
                    nja.skill.add(skill);
                }
            }
            JSONArray jarr2 = (JSONArray) JSONValue.parse(red.getString("KSkill"));
            nja.KSkill = new byte[jarr2.size()];
            for (byte j = 0; j < nja.KSkill.length; j++) {
                nja.KSkill[j] = Byte.parseByte(jarr2.get(j).toString());
            }
            jarr2 = (JSONArray) JSONValue.parse(red.getString("OSkill"));
            nja.OSkill = new byte[jarr2.size()];
            for (byte j = 0; j < nja.OSkill.length; j++) {
                nja.OSkill[j] = Byte.parseByte(jarr2.get(j).toString());
            }
            nja.CSkill = Byte.parseByte(red.getString("CSkill"));
            nja.level = red.getShort("level");
            nja.exp = red.getLong("exp");
            nja.expdown = red.getInt("expdown");
            nja.xu = red.getInt("xu");
            nja.expdown = red.getInt("expdown");
            nja.xuBox = red.getInt("xuBox");
            nja.yen = red.getInt("yen");
            nja.maxluggage = red.getByte("maxluggage");
            nja.levelBag = red.getByte("levelBag");
            nja.ItemBag = new Item[nja.maxluggage];
            jar = (JSONArray) JSONValue.parse(red.getString("ItemBag"));
            if (jar != null) {
                for (byte j = 0; j < jar.size(); j++) {
                    JSONObject job = (JSONObject) jar.get(j);
                    byte index = Byte.parseByte(job.get("index").toString());
                    nja.ItemBag[index] = ItemData.parseItem(jar.get(j).toString());
                }
            }
            nja.ItemBox = new Item[30];
            jar = (JSONArray) JSONValue.parse(red.getString("ItemBox"));
            if (jar != null) {
                for (byte j = 0; j < jar.size(); j++) {
                    JSONObject job = (JSONObject) jar.get(j);
                    byte index = Byte.parseByte(job.get("index").toString());
                    nja.ItemBox[index] = ItemData.parseItem(jar.get(j).toString());
                }
            }
            nja.ItemBody = new Item[16];
            jar = (JSONArray) JSONValue.parse(red.getString("ItemBody"));
            if (jar != null) {
                for (byte j = 0; j < jar.size(); j++) {
                    JSONObject job = (JSONObject) jar.get(j);
                    byte index = Byte.parseByte(job.get("index").toString());
                    nja.ItemBody[index] = ItemData.parseItem(jar.get(j).toString());
                }
            }
            nja.ItemMounts = new Item[5];
            jar = (JSONArray) JSONValue.parse(red.getString("ItemMounts"));
            if (jar != null) {
                for (byte j = 0; j < jar.size(); j++) {
                    JSONObject job = (JSONObject) jar.get(j);
                    byte index = Byte.parseByte(job.get("index").toString());
                    nja.ItemMounts[index] = ItemData.parseItem(jar.get(j).toString());
                }
            }
            nja.friend = red.getString("friend");
            jar = (JSONArray) JSONValue.parse(red.getString("site"));
            nja.map = Byte.parseByte(jar.get(0).toString());
            nja.x = Short.parseShort(jar.get(1).toString());
            nja.y = Short.parseShort(jar.get(2).toString());
            red.close();
            return nja;
        } catch (SQLException | NumberFormatException ex) {
            p.conn.disconnect();
            ex.printStackTrace();
        }
        return null;
    }
    
    protected void flush() {
        JSONArray jarr = new JSONArray();
        try {
            jarr.add(map);
            jarr.add(x);
            jarr.add(y);
            String sqlSET = "`taskId`=" + taskId + ",`class`=" + nclass + ",`ppoint`=" + ppoint + ",`potential0`=" + potential0 + ",`potential1`=" + potential1 + ",`potential2`=" + potential2 + ",`potential3`=" + potential3 + ",`spoint`=" + spoint + ",`level`=" + level + ",`exp`="+exp+",`expdown`="+expdown+",`xu`=" + xu + ",`yen`=" + yen + ",`maxluggage`="+maxluggage+",`levelBag`="+levelBag+",`site`='" + jarr.toJSONString() + "',`friend`='" + friend + "'";
            jarr.clear();
            //Ki nang
            for (Skill skill : skill) {
                jarr.add(SkillData.ObjectSkill(skill));
            }
            sqlSET += ",`skill`='" + jarr.toJSONString() + "'";
            jarr.clear();
            //Dan 5 Ki nang
            for (byte oid : KSkill) {
                jarr.add(oid);
            }
            sqlSET += ",`KSkill`='" + jarr.toJSONString() + "'";
            jarr.clear();
            //Dan 5 Ki nang
            for (byte oid : OSkill) {
                jarr.add(oid);
            }
            sqlSET += ",`OSkill`='" + jarr.toJSONString() + "',`CSkill`=" + CSkill + "";
            jarr.clear();
            //ruong hanh trang
            for (byte j = 0; j < ItemBag.length; j++) {
                Item item = ItemBag[j];
                if (item == null) {
                    continue;
                }
                jarr.add(ItemData.ObjectItem(item, j));
            }
            sqlSET += ",`ItemBag`='" + jarr.toJSONString() + "'";
            jarr.clear();
            //ruong do
            for (byte j = 0; j < ItemBox.length; j++) {
                Item item = ItemBox[j];
                if (item == null) {
                    continue;
                    }
                jarr.add(ItemData.ObjectItem(item, j));
            }
            sqlSET += ",`xuBox`=" + xuBox + ",`ItemBox`='" + jarr.toJSONString() + "'";
            jarr.clear();
            //ruong do trang bi
            for (byte j = 0; j < ItemBody.length; j++) {
                Item item = ItemBody[j];
                if (item == null) {
                    continue;
                }
                jarr.add(ItemData.ObjectItem(item, j));
            }
            sqlSET += ",`ItemBody`='" + jarr.toJSONString() + "'";
            jarr.clear();
            //ruong thu cuoi
            for (byte j = 0; j < ItemMounts.length; j++) {
                Item item = ItemMounts[j];
                if (item == null) {
                    continue;
                }
               jarr.add(ItemData.ObjectItem(item, j));
            }
            sqlSET += ",`ItemMounts`='" + jarr.toJSONString() + "'";
            SQLManager.stat.executeUpdate("UPDATE `ninja` SET " + sqlSET + " WHERE `id`=" + id + " LIMIT 1;");
            jarr.clear();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    
    public void close() {
        place.leave(p);
    }
}
