
package real;

import server.SQLManager;
import io.Message;
import io.Session;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.JSONValue;
import server.GameScr;
import server.Server;
import server.util;

/**
 *
 * @author Văn Tú
 */
public class Player extends Actor {

    public String username = null;
    public String version = null;
    public Session conn = null;
    public Ninja nj = null;
    

    Server server = Server.getInstance();

    public void cleanup() {
        conn = null;
    }

    public int upluong(long x) {
        long luongnew = (long) luong + x;
        if (luongnew > 2000000000) {
            x = 2000000000 - luong;
        } else if (luongnew < -2000000000) {
            x = -2000000000 - luong;
        }
        luong += x;
        return (int) x;
    }

    public static Player login(Session conn, String user, String pass) {
        try {
            Player p = new Player();
            ResultSet red = SQLManager.stat.executeQuery("SELECT * FROM `player` WHERE (`username`=\""+user+"\" AND `password`=\""+pass+"\") LIMIT 1;");
            if (red.first()) {
                p.conn = conn;
                p.id = red.getInt("id");
                p.username = user;
                p.luong = red.getInt("luong");
                JSONArray jarr = (JSONArray) JSONValue.parse(red.getString("ninja"));
                red.close();
                Player p2 = PlayerManager.getInstance().getPlayer(user);
                if (p2 != null) {
                    p2.conn.sendMessageLog("Có người đăng nhập vào tài khoản của bạn");
                    p2.conn.disconnect();
                    p.conn.sendMessageLog("Bạn đang đăng nhập tại máy khác. Hãy thử đăng nhập lại");
                    return null;
                } else {
                    for (byte i = 0; i < jarr.size(); i++) {
                        p.sortNinja[i] = jarr.get(i).toString();
                    }
                    PlayerManager.getInstance().put(p);
                    return p;
                }
            } else {
                conn.sendMessageLog("Thông tin tài khoản hoặc mật khẩu không chính xác");
            }
        } catch (Exception e) {
            conn.disconnect();
            e.printStackTrace();
        }
        return null;
    }

    public void messageSubCommand(Message m) throws IOException {
        byte b = m.reader().readByte();
        //util.Debug("Cmd -30->" + b);
        switch (b) {
            //Cong diem tiem nang
            case -109:
                pluspPoint(m);
                break;
            //cong diem ki nang
            case -108:
                plusSkillpoints(m);
                break;
            //xep hanh trang
            case -107:
                nj.sortBag();
                break;
            //xep ruong
            case -106:
                nj.sortBox();
                break;
            case -105:
                xuBagtoBox(m);
                break;
            //rut xu
            case -104:
                xuBoxtoBag(m);
                break;
            //
            case -103:
                GameScr.ItemInfo(this, m);
                break;
            //Che do pk
            case -93:
                nj.place.changerTypePK(this, m);
                break;
            //Xem ban be
            case -85:
                viewFriend();
                break;
            //Xoa ban be
            case -83:
                deleteFriend(m);
                break;
            //Dab chieu
            case -67:
                pasteSkill(m);
                break;
            case -65:
                GameScr.sendSkill(this, m);
                break;
        }
    }

    private void sendInfo() throws IOException {
        nj.hp = nj.getMaxHP();
        nj.mp = nj.getMaxMP();
        Message m = new Message(-30);
        m.writer().writeByte(-127);
        m.writer().writeInt(nj.id);//id ninja
        m.writer().writeUTF(nj.clanName);// clan name
        if (!nj.clanName.isEmpty()) {
            m.writer().writeByte(nj.typeclan);//type clan
        }
        m.writer().writeByte((nj.taskId = 50));//taskId (id nhiem vu)
        m.writer().writeByte(nj.gender);// gender
        m.writer().writeShort(nj.head);// head defult
        m.writer().writeByte(nj.speed());//speed
        m.writer().writeUTF(nj.name);//neame
        m.writer().writeByte(nj.pk);//pk
        m.writer().writeByte(nj.typepk);//type pk
        m.writer().writeInt(nj.getMaxHP()); // maxHP
        m.writer().writeInt(nj.hp); // hp
        m.writer().writeInt(nj.getMaxMP()); // maxMP
        m.writer().writeInt(nj.mp); // mp
        m.writer().writeLong(nj.exp); // exp
        m.writer().writeLong(nj.expdown); //exp dowm
        m.writer().writeShort(nj.eff5buffHP()); // eff5buff
        m.writer().writeShort(nj.eff5buffMP()); // eff5buff
        m.writer().writeByte(nj.nclass);// nclass
        m.writer().writeShort(nj.ppoint); //ppoint
        m.writer().writeShort(nj.potential0); //potential 0
        m.writer().writeShort(nj.potential1); //potential 1
        m.writer().writeInt(nj.potential2); //potential 2
        m.writer().writeInt(nj.potential3); //potential 3
        m.writer().writeShort(nj.spoint); // spoint
        m.writer().writeByte(nj.skill.size());// skill lent
        for (Skill skill : nj.skill) {
            m.writer().writeShort(SkillData.Templates(skill.id, skill.point).skillId);//id skill
        }
        m.writer().writeInt(nj.xu);//xu
        m.writer().writeInt(nj.yen);//yen
        m.writer().writeInt(luong);//luong
        m.writer().writeByte(nj.maxluggage);//IteamBag max leght
        for (byte i = 0; i < nj.maxluggage; i++) {
            Item item = nj.ItemBag[i];
            if (item != null) {
                m.writer().writeShort(item.id);//id
                m.writer().writeBoolean(item.isLock);//khoa
                if (ItemData.isTypeBody(item.id) || ItemData.isTypeMounts(item.id) || ItemData.isTypeNgocKham(item.id)) {
                    m.writer().writeByte(item.upgrade);//nang cap +0-16 
                }
                m.writer().writeBoolean(item.isExpires);//het han
                m.writer().writeShort(item.quantity);//dinh luong
            } else {
                m.writer().writeShort(-1);
            }
        }
        // trang bi
        for (int i = 0; i < 16; i++) {
            Item item = nj.ItemBody[i];
            if (item != null) {
                m.writer().writeShort(item.id);
                m.writer().writeByte(item.upgrade);
                m.writer().writeByte(item.sys);
            } else {
                m.writer().writeShort(-1);
            }
        }
        m.writer().writeBoolean(true);
        m.writer().writeBoolean(false);
        m.writer().writeShort(nj.partHead());
        m.writer().writeShort(nj.Weapon());
        m.writer().writeShort(nj.Body());
        m.writer().writeShort(nj.Leg());
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
        for (Map map : server.map) {
            if (map.id != nj.map) {
                continue;
            }
            for (byte i = 0; i < map.area.length; i++) {
                if (map.area[i].numplayers < map.maxplayers) {
                    map.area[i].Enter(this);
                    return;
                }
            }
            map.area[util.nextInt(map.area.length)].Enter(this);
        }
    }

    public void processGameMessage(Message m) throws Exception {
        byte msg = m.reader().readByte();
        util.Debug("-28->" + msg);
        switch (msg) {
            //Chon nhan vat
            case -126:
                selectNhanVat(m);
                break;
            //Tao nhan vat
            case -125:
                createHero(m);
                break;
            case -122:
                server.manager.sendData(this);
                break;
            case -121:
                server.manager.sendMap(this);
                break;
            case -120:
                server.manager.sendSkill(this);
                break;
            case -119:
                server.manager.sendItem(this);
                break;
            //IMG Icon
            case -115:
                GameScr.reciveImage(this, m);
                break;
//            case -101:
//                selectNhanVat(null);
//                break;
            //Tach item 
            case -85:
                ItemData.divedeItem(this, m);
                break;
            //Lat hinh
            case -72:
                GameScr.LuckValue(this, m);
                break;

        }
        m.cleanup();
    }

    public void Admission(byte nclass) throws IOException {
        nj.nclass = nclass;
        nj.skill.clear();
        nj.upHP(nj.getMaxHP());
        nj.upMP(nj.getMaxMP());
        nj.spoint = Level.totalsPoint(nj.level);
        nj.ppoint = Level.totalpPoint(nj.level);
        nj.potential0 = 15;
        nj.potential1 = 5;
        nj.potential2 = 5;
        nj.potential3 = 5;
        Message m = new Message(-30);
        m.writer().writeByte(-126);
        m.writer().writeByte(nj.speed());//speed
        m.writer().writeInt(nj.getMaxHP());//hpmaxx
        m.writer().writeInt(nj.getMaxMP());//mp max
        m.writer().writeShort(nj.potential0);
        m.writer().writeShort(nj.potential1);
        m.writer().writeInt(nj.potential2);
        m.writer().writeInt(nj.potential3);
        m.writer().writeByte(nj.nclass);// class
        m.writer().writeShort(nj.spoint);
        m.writer().writeShort(nj.ppoint);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    private void plusSkillpoints(Message m) throws IOException {
        short sk = m.reader().readShort();
        byte point = m.reader().readByte();
        m.cleanup();
        Skill skill = nj.getSkill(sk);
        if (skill == null || nj.spoint <= 0 || point <= 0) {
            return;
        }
        SkillData data = SkillData.Templates(sk);
        if (point + skill.point > data.maxPoint) {
            conn.sendMessageLog("Cấp tối đa là " + data.maxPoint);
            return;
        }
        skill.point += point;
        nj.spoint -= point;
        nj.upHP(nj.getMaxHP());
        nj.upMP(nj.getMaxMP());
        viewInfoPlayers(this);
        loadSkill();
    }

    private void loadSkill() throws IOException {
        Message m = new Message(-30);
        m.writer().writeByte(-125);
        m.writer().writeByte(nj.speed());
        m.writer().writeInt(nj.getMaxHP());
        m.writer().writeInt(nj.getMaxMP());
        m.writer().writeShort(nj.spoint);
        m.writer().writeByte(nj.skill.size());
        for (Skill fs : nj.skill) {
            m.writer().writeShort(SkillData.Templates(fs.id, fs.point).skillId);
        }
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    private void pluspPoint(Message m) throws IOException {
        if (nj.nclass == 0) {
            return;
        }
        byte num = m.reader().readByte();
        short quantity = m.reader().readShort();
        m.cleanup();
        if (1 > nj.ppoint) {
                    conn.sendMessageLog("Bạn không đủ điểm cộng.");
                     return;
                   }
        if (quantity > 0 && quantity <= nj.ppoint) {
            switch (num) {
                case 0:
                    if(nj.potential0 > 2889 ) nj.potential0 = 2889;
                    nj.potential0 += quantity;
                    break;
                case 1:
                    if(nj.potential1 > 1000 ) nj.potential1 = 1000;
                    nj.potential1 += quantity;
                    break;
                case 2:
                    if(nj.potential2 > 2889 ) nj.potential2 = 2889;
                    nj.potential2 += quantity;
                    break;
                case 3:
                    if(nj.potential3 > 2889 ) nj.potential3 = 2889;
                    nj.potential3 += quantity;
                    break;
                default:
                    return;
            }
        }
        nj.ppoint -= quantity;
        nj.upHP(nj.getMaxHP());
        nj.upMP(nj.getMaxMP());
        m = new Message(-30);
        m.writer().writeByte(-109);
        m.writer().writeByte(nj.speed());
        m.writer().writeInt(nj.getMaxHP());
        m.writer().writeInt(nj.getMaxMP());
        m.writer().writeShort(nj.ppoint);
        m.writer().writeShort(nj.potential0);
        m.writer().writeShort(nj.potential1);
        m.writer().writeInt(nj.potential2);
        m.writer().writeInt(nj.potential3);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    private void xuBagtoBox(Message m) throws IOException {
        int xu = m.reader().readInt();
        if (xu <= 0 || xu > nj.xu) {
            return;
        }
        if ((long) xu + nj.xuBox > 2000000000) {
            conn.sendMessageLog("Bạn chỉ có thể cất thêm " + util.getFormatNumber(((long) xu + nj.xu) - 2000000000));
            return;
        }
        nj.xu -= xu;
        nj.xuBox += xu;
        m = new Message(-30);
        m.writer().writeByte(-105);
        m.writer().writeInt(xu);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    private void xuBoxtoBag(Message m) throws IOException {
        int xu = m.reader().readInt();
        if (xu <= 0 || xu > nj.xuBox) {
            return;
        }
        if ((long) xu + nj.xu > 2000000000) {
            conn.sendMessageLog("Bạn chỉ có thể rút thêm " + util.getFormatNumber(((long) xu + nj.xu) - 2000000000));
            return;
        }
        nj.xu += xu;
        nj.xuBox -= xu;
        m = new Message(-30);
        m.writer().writeByte(-104);
        m.writer().writeInt(xu);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }
    
    public void openBagLevel(byte index) throws IOException {
        Message m = new Message(-30);
        m.writer().writeByte(-91);
        m.writer().writeByte(nj.ItemBag.length);
        m.writer().writeByte(index);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void viewFriend() throws IOException {
        Message m = new Message(-30);
        m.writer().writeByte(-85);
        JSONArray jar = (JSONArray) JSONValue.parse(nj.friend);
        byte i = 0;
        byte turn = 0;
        while (jar.size() > 0) {
            if (i == jar.size()) {
                i = 0;
                turn++;
                if (turn == 3) {
                    break;
                }
            }
            JSONObject job = (JSONObject) jar.get(i);
            if (Boolean.parseBoolean(job.get("agree").toString())) {
                Ninja n = PlayerManager.getInstance().getNinja(job.get("name").toString());
                if (turn == 0 && n != null) {
                    m.writer().writeUTF(job.get("name").toString());
                    m.writer().writeByte(3);
                } else if (turn == 1 && n == null) {
                    m.writer().writeUTF(job.get("name").toString());
                    m.writer().writeByte(1);
                }
            } else if (turn == 2) {
                m.writer().writeUTF(job.get("name").toString());
                m.writer().writeByte(-1);
            }
            i++;
        }
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    protected void deleteFriend(Message m) throws IOException {
        String nF = m.reader().readUTF();
        m.cleanup();
        JSONArray jar = (JSONArray) JSONValue.parse(nj.friend);
        for (int i = 0; i < jar.size(); i++) {
            JSONObject job = (JSONObject) jar.get(i);
            if (job.get("name").toString().equals(nF)) {
                jar.remove(i);
                nj.friend = jar.toJSONString();
                m = new Message(-30);
                m.writer().writeByte(-83);
                m.writer().writeUTF(nF);
                m.writer().flush();
                conn.sendMessage(m);
                m.cleanup();
                return;
            }
        }
    }

    private void pasteSkill(Message m) throws IOException {
        String t1 = m.reader().readUTF();
        String t2 = m.reader().readUTF();
        short lent = m.reader().readShort();
        switch (t1) {
            case "KSkill":
                for (byte i = 0; i < nj.KSkill.length; i++) {
                    byte sid = m.reader().readByte();
                    if (sid == -1) {
                        continue;
                    }
                    Skill skill = nj.getSkill(sid);
                    if (skill != null && SkillData.Templates(skill.id).type != 0) {
                        nj.KSkill[i] = skill.id;
                    }
                }
                break;
            case "OSkill":
                for (byte i = 0; i < nj.OSkill.length; i++) {
                    byte sid = m.reader().readByte();
                    if (sid == -1) {
                        continue;
                    }
                    Skill skill = nj.getSkill(sid);
                    if (skill != null && SkillData.Templates(skill.id).type != 0) {
                        nj.OSkill[i] = skill.id;
                    }
                }
                break;
        }
        m.cleanup();
    }

    public void selectNhanVat(Message m) throws Exception {
        if (m != null && nj == null) {
            String name = m.reader().readUTF();
            for (byte i = 0; i < sortNinja.length; i++) {
                if (name.equals(sortNinja[i])) {
                    nj = Ninja.setup(this, sortNinja[i]);
                    PlayerManager.getInstance().put(nj);
                    break;
                }
            }
            sendInfo();
            return;
        }
        m = new Message(-28);
        m.writer().writeByte(-126);
        //lent hero
        byte lent = 0;
        for (byte i = 0; i < sortNinja.length; i++) {
            if (sortNinja[i] != null) {
                lent++;
            }
        }
        m.writer().writeByte(lent);
        ResultSet red;
        for (byte i = 0; i < sortNinja.length; i++) {
            if (sortNinja[i] == null) {
                continue;
            }
            red = SQLManager.stat.executeQuery("SELECT `gender`,`class`,`level`,`head`,`ItemBody` FROM `ninja` WHERE `name`=\"" + sortNinja[i] + "\" LIMIT 1;");
            red.first();
            m.writer().writeByte(red.getByte("gender")); // gt
            m.writer().writeUTF(sortNinja[i]); // name
            m.writer().writeUTF(server.manager.NinjaS[red.getByte("class")]); // lop
            m.writer().writeByte(red.getInt("level"));// Level
            byte head = red.getByte("head");
            JSONArray jar = (JSONArray) JSONValue.parse(red.getString("ItemBody"));
            red.close();
            Item[] body = new Item[16];
            if (jar != null) {
                for (byte j = 0; j < jar.size(); j++) {
                    JSONObject job = (JSONObject) jar.get(j);
                    byte index = Byte.parseByte(job.get("index").toString());
                    body[index] = ItemData.parseItem(jar.get(j).toString());
                }
            }
            if (body[11] == null) {
                m.writer().writeShort(head); // dau
            } else {
                m.writer().writeShort(ItemData.ItemDataId(body[11].id).part); // dau
            }
            if (body[1] == null) {
                m.writer().writeShort(-1); // vu khi
            } else {
                m.writer().writeShort(ItemData.ItemDataId(body[1].id).part);
            }
            if (body[2] == null) {
                m.writer().writeShort(-1); // body
            } else {
                m.writer().writeShort(ItemData.ItemDataId(body[2].id).part);
            }
            if (body[6] == null) {
                m.writer().writeShort(-1); // chan
            } else {
                m.writer().writeShort(ItemData.ItemDataId(body[6].id).part);
            }
        }
        m.writer().flush();
        server.manager.sendTB(this, "Thông Báo", "Nhập Học Vs Cho Đồ All Trong Rương Đồ Về +0 Ở Trưởng Làng. \n mọi người lên lv bằng cách ăn diều hoặc Pk đồ sát nhau Sẽ được diều kiếm bằng cách lật hình vs pk người , pk người rơi ra bát bảo vs rương bạch ngân vs diều vs kinh  nghiệm. \n -Tất cả Đồ Trang Bị Ngẫu Nhiên Như Sau : \n -Trang Bị và Vk có CS : HP Và MP (1000-4000) : TC(2000-6000) \n -Thú Nuôi và Bí Kíp và Nhẫn Thuật GT Có Cs : HP Và MP (1000-2500) Tc (2000-4000) \n -Yoroi và Mắt Có Cs : HP và MP (1000-2000) TC (1000-3000) Né (1-500) \n -Mặt Nạ cs : HP và MP (1000-2000) TC (1000-3000) Né (1-500). \n Game Free 100% Nhé Mn Chơi Vui Vẻ  \n  Chúc mọi người chơi vui vẻ");
        conn.sendMessage(m);
        m.cleanup();
    }

    private void createHero(Message m) throws Exception {
        if (sortNinja[2] != null) {
            return;
        }
        String name = m.reader().readUTF().toLowerCase();
        byte gender = m.reader().readByte();
        byte head = m.reader().readByte();
        m.cleanup();
        if (!util.CheckString(name, "^[a-zA-Z0-9]+$") || name.length() < 5 || name.length() > 10) {
            conn.sendMessageLog("Tên nhân chỉ đồng ý các ký tự a-z,0-9 và chiều dài từ 5 đến 10 ký tự");
            return;
        }
        ResultSet red = SQLManager.stat.executeQuery("SELECT `id` FROM `ninja` WHERE `name`=\"" + name + "\" LIMIT 1;");
        if (red.first()) {
            conn.sendMessageLog("Tên nhân vật đã tồn tại!");
            red.close();
            return;
        }
        SQLManager.stat.executeUpdate("INSERT INTO ninja(`name`,`gender`,`head`,`ItemBag`,`ItemBox`,`ItemBody`,`ItemMounts`) VALUES (\"" + name + "\"," + gender + "," + head + ",'[]','[]','[]','[]');");
        for (byte i = 0; i < sortNinja.length; i++) {
            if (sortNinja[i] == null) {
                sortNinja[i] = name;
                break;
            }
        }
        flush();
        selectNhanVat(null);
    }

    public void sendAddchatYellow(String str) {
        try {
            Message m = new Message(-24);
            m.writer().writeUTF(str);
            m.writer().flush();
            conn.sendMessage(m);
            m.cleanup();
        } catch (IOException ex) {
        }
    }

    public void privateChat(Message m) throws IOException {
        String name = m.reader().readUTF();
        String chat = m.reader().readUTF();
        Ninja n = PlayerManager.getInstance().getNinja(name);
        if (n == null || n == nj) {
            return;
        }
        m = new Message(-22);
        m.writer().writeUTF(nj.name);
        m.writer().writeUTF(chat);
        m.writer().flush();
        nj.p.conn.sendMessage(m);
        m.cleanup();
    }

    public void luongMessage(long luongup) {
        upluong(luongup);
        try {
            Message m = new Message(-30);
            m.writer().writeByte(-72);
            m.writer().writeInt(luong);
            m.writer().flush();
            conn.sendMessage(m);
            m.cleanup();
        } catch (IOException ex) {
        }
    }

    public void upluongMessage(long luongup) {
        try {
            Message m = new Message(-30);
            m.writer().writeByte(-71);
            m.writer().writeInt(upluong(luongup));
            m.writer().flush();
            conn.sendMessage(m);
            m.cleanup();
        } catch (IOException ex) {
        }
    }

    public void useItem(Message m) throws IOException {
        byte index = m.reader().readByte();
        m.cleanup();
        Item item = nj.getIndexBag(index);
        if (item == null) {
            return;
        }
        ItemData.uesItem(this, item, index);
    }

    private synchronized void setMoney(int sxu, int syen, int sluong) {
        nj.xu = sxu;
        nj.yen = syen;
        luong = sluong;
        try {
            Message m = new Message(13);
            m.writer().writeInt(nj.xu);
            m.writer().writeInt(nj.yen);
            m.writer().writeInt(luong);
            m.writer().flush();
            conn.sendMessage(m);
            m.cleanup();
        } catch (IOException ex) {
        }
    }

    public void SellItemBag(Message m) throws IOException {
        byte index = m.reader().readByte();
        int num = 1;
        if (m.reader().available() > 0)
            num = m.reader().readInt();
        m.cleanup();
        Item item = nj.getIndexBag(index);
        if (item == null || num <= 0 || num > item.quantity)
            return;
        item.quantity -= num;
        if (item.quantity <= 0)
            nj.ItemBag[index] = null;
        nj.upyen(item.saleCoinLock*num);
        m = new Message(14);
        m.writer().writeByte(index);//vi tri
        m.writer().writeInt(nj.yen);//yen
        m.writer().writeShort(num);//so luong
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void itemBodyToBag(Message m) throws IOException {
        byte index = m.reader().readByte();
        m.cleanup();
        Item itembody = nj.ItemBody[index];
        byte idItemBag = nj.getIndexBagNotItem();
        nj.ItemBag[idItemBag] = itembody;
        nj.ItemBody[index] = null;
        m = new Message(15);
        m.writer().writeByte(nj.speed());//speed
        m.writer().writeInt(nj.getMaxHP());//hp
        m.writer().writeInt(nj.getMaxMP());//mp
        m.writer().writeShort(0);//hp
        m.writer().writeShort(0);//mp
        m.writer().writeByte(index);//vi tri trang bi
        m.writer().writeByte(idItemBag);//index ItemBag
        m.writer().writeShort(nj.head);//head
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void itemBoxToBag(Message m) throws IOException {
        byte index = m.reader().readByte();
        m.cleanup();
        Item item = nj.getIndexBox(index);
        if (item == null) {
            return;
        }
        ItemData data = ItemData.ItemDataId(item.id);
        byte indexBag = nj.getIndexBagid(item.id, item.isLock);
        if (!item.isExpires && data.uptoup && indexBag != -1) {
            nj.ItemBox[index] = null;
            nj.ItemBag[indexBag].quantity += item.quantity;
        } else if (nj.getBagNull() > 0) {
            indexBag = nj.getIndexBagNotItem();
            nj.ItemBox[index] = null;
            nj.ItemBag[indexBag] = item;
        } else {
            conn.sendMessageLog("Rương đồ không đủ chỗ trống");
            return;
        }
        m = new Message(16);
        m.writer().writeByte(index);
        m.writer().writeByte(indexBag);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void itemBagToBox(Message m) throws IOException {
        byte index = m.reader().readByte();
        m.cleanup();
        Item item = nj.getIndexBag(index);
        if (item == null) {
            return;
        }
        ItemData data = ItemData.ItemDataId(item.id);
        byte indexBox = nj.getIndexBoxid(item.id, item.isLock);
        if (!item.isExpires && data.uptoup && indexBox != -1) {
            nj.ItemBag[index] = null;
            nj.ItemBox[indexBox].quantity += item.quantity;
        } else if (nj.getBoxNull() > 0) {
            indexBox = nj.getIndexBoxNotItem();
            nj.ItemBag[index] = null;
            nj.ItemBox[indexBox] = item;
        } else {
            conn.sendMessageLog("Rương đồ không đủ chỗ trống");
            return;
        }
        m = new Message(17);
        m.writer().writeByte(index);
        m.writer().writeByte(indexBox);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void requestItem(int typeUI) throws IOException {
        Message m = new Message(30);
        m.writer().writeByte(typeUI);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void requestItemInfo(Message m) throws IOException {
        byte type = m.reader().readByte();
        int index = m.reader().readUnsignedByte();
        util.Debug("type " + type + " index" + index);
        m.cleanup();
        Item item = null;
        switch (type) {
            //xem info hanh trang
            case 3:
                if (index < 0 || index >= nj.maxluggage) {
                    return;
                }
                item = nj.ItemBag[index];
                break;
            //xem info ruong do
            case 4:
                if (index < 0 || index >= 30)
                    return;
                item = nj.ItemBox[index];
                break;
            //xem info trang bi
            case 5:
                if (index < 0 || index > 15)
                    return;
                item = nj.ItemBody[index];
                break;
            //xem info thuc an
            case 8:
                item = ItemSell.getItemTypeIndex(type, index);
                break;
            //xem info thuc an khoa
            case 9:
                item = ItemSell.getItemTypeIndex(type, index);
                break;
            //xem info cua hang
            case 14:
                item = ItemSell.getItemTypeIndex(type, index);
                break;
            //xem info cua hang sach
            case 15:
                item = ItemSell.getItemTypeIndex(type, index);
                break;
            //xem info thoi trang
            case 32:
                item = ItemSell.getItemTypeIndex(type, index);
                break;
            //xem info thu cuoi
            case 41:
                if (index < 0 || index > 4)
                    return;
                item = nj.ItemMounts[index];
                break;
        }
        if (item == null) {
            //util.Debug("null item");
            return;
        }
        m = new Message(42);
        m.writer().writeByte(type);
        m.writer().writeByte(index);
        m.writer().writeLong(item.expires);
        if (ItemData.isTypeUIME(type)) {
            m.writer().writeInt(item.saleCoinLock);
        }
        if (ItemData.isTypeUIShop(type) || ItemData.isTypeUIShopLock(type) || ItemData.isTypeMounts(type) || ItemData.isTypeUIStore(type) || ItemData.isTypeUIBook(type) || ItemData.isTypeUIFashion(type) || ItemData.isTypeUIClanShop(type)) {
            m.writer().writeInt(item.buyCoin);
            m.writer().writeInt(item.buyCoinLock);
            m.writer().writeInt(item.buyGold);
        }
        if (ItemData.isTypeBody(item.id) || ItemData.isTypeMounts(item.id) || ItemData.isTypeNgocKham(item.id)) {
            m.writer().writeByte(item.sys);//thuoc tinh
            if (item.option != null) {
                for (Option Option : item.option) {
                    m.writer().writeByte(Option.id);
                    m.writer().writeInt(Option.param);
                }
            }
        }
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void requestTrade(Message m) throws IOException {
        int ids = m.reader().readInt();
        m.cleanup();
        Player p = nj.place.getNinja(ids).p;
        if (p == null) {
            sendAddchatYellow("Người này không ở cùng khu hoặc đã offline.");
        } else if (Math.abs(nj.x - p.nj.x) > 100 || Math.abs(nj.y - p.nj.y) > 100) {
            sendAddchatYellow("Khoảng cách quá xa.");
        } else if (trade.delay > 0) {
            conn.sendMessageLog("Bạn còn " + (trade.delay / 100) + "s để tiếp tục giao dịch.");
        } else if (trade.name != null) {
            conn.sendMessageLog(p.nj.name + " đang có yêu cầu giao dịch.");
        } else if (p.trade.name != null) {
            conn.sendMessageLog(p.nj.name + " đang có yêu cầu giao dịch.");
        } else if (p.trade.lock >= 0) {
            conn.sendMessageLog(p.nj.name + " đang thực hiện giao dịch.");
        } else {
            trade.delay = 3000;
            p.trade.name = nj.name;
            m = new Message(43);
            m.writer().writeInt(nj.id);
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
        }
    }

    public void startTrade(Message m) throws IOException {
        int ids = m.reader().readInt();
        m.cleanup();
        if (trade.lock >= 0) {
            conn.sendMessageLog("Bạn đã có giao dịch.");
            return;
        }
        Player p = nj.place.getNinja(ids).p;
        if (p == null) {
            sendAddchatYellow("Người này không ở cùng khu hoặc đã offline.");
        } else if (Math.abs(nj.x - p.nj.x) > 100 || Math.abs(nj.y - p.nj.y) > 100) {
            sendAddchatYellow("Khoảng cách quá xa.");
        } else if (p.trade.lock >= 0) {
            conn.sendMessageLog(p.nj.name + " đã có giao dịch.");
        } else {
            p.nj.type = 10;
            p.trade.ClearItem();
            p.trade.name = nj.name;
            p.trade.lock = 0;
            nj.type = 10;
            trade.ClearItem();
            trade.lock = 0;
            m = new Message(37);
            m.writer().writeUTF(p.nj.name);//name trade
            m.writer().flush();
            conn.sendMessage(m);
            m.cleanup();
            m = new Message(37);
            m.writer().writeUTF(nj.name);//name trade
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
            return;
        }
        trade.name = null;
    }

    public void lockTrade(Message m) throws IOException {
        if (trade.lock == 0) {
            trade.lock++;
            trade.ClearItem();
            Ninja n = PlayerManager.getInstance().getNinja(trade.name);
            int tradexu = m.reader().readInt();//xu;
            if (tradexu > 0 && tradexu <= nj.xu) {
                trade.xu = tradexu;
            }
            byte lent = m.reader().readByte();//item
            for (byte i = 0; i < lent; i++) {
                byte index = m.reader().readByte();//index item ItemBag
                Item item = nj.getIndexBag(index);
                if (item != null && !item.isLock) {
                    trade.AddItem(index);
                }

            }
            if (trade.geNumItemTrade() > n.getBagNull()) {
                closeTrade();
                return;
            }
            m.cleanup();
            m = new Message(45);
            m.writer().writeInt(trade.xu);
            m.writer().writeByte(trade.geNumItemTrade());//item
            for (byte i = 0; i < trade.item.length; i++) {
                Item item = nj.getIndexBag(trade.item[i]);
                if (item == null) {
                    continue;
                }
                m.writer().writeShort(item.id);//id
                if (ItemData.isTypeBody(item.id) || ItemData.isTypeNgocKham(item.id)) {
                    m.writer().writeByte(item.upgrade);//+0-16
                }
                m.writer().writeBoolean(item.isExpires);//hsd
                m.writer().writeShort(item.quantity);//so luong
            }
            m.writer().flush();
            n.p.conn.sendMessage(m);
            m.cleanup();
        }
    }

    public void agreeTrade() throws IOException {
        if (trade.lock == 1) {
            Ninja n = PlayerManager.getInstance().getNinja(trade.name);
            trade.lock++;
            Message m = new Message(46);
            m.writer().flush();
            n.p.conn.sendMessage(m);
            m.cleanup();
            if (n.p.trade.lock == 2) {
                closeTrade();
                if (n.p.trade.xu > 0) {
                    n.p.nj.upxuMessage(-n.p.trade.xu);
                    nj.upxuMessage(+n.p.trade.xu);
                }
                if (trade.xu > 0) {
                    nj.upxuMessage(-trade.xu);
                    n.p.nj.upxuMessage(+trade.xu);
                }
                for (byte i = 0; i < n.p.trade.item.length; i++) {
                    if (n.p.trade.item[i] != -1) {
                        Item item = n.p.nj.getIndexBag(n.p.trade.item[i]);
                        if (item != null) {
                            nj.addItemBag(true, item);
                        }
                    }
                }
                for (byte i = 0; i < trade.item.length; i++) {
                    Item item = nj.getIndexBag(trade.item[i]);
                    if (item != null) {
                        n.addItemBag(true, item);
                    }
                }
                for (byte i = 0; i < n.p.trade.item.length; i++) {
                    Item item = n.p.nj.getIndexBag(n.p.trade.item[i]);
                    if (item != null) {
                        n.removeItemBag(n.p.trade.item[i], item.quantity);
                    }
                }
                for (byte i = 0; i < trade.item.length; i++) {
                    Item item = nj.getIndexBag(trade.item[i]);
                    if (item != null) {
                        nj.removeItemBag(trade.item[i], item.quantity);
                    }
                }
            }
        }
    }

    public void closeTrade() throws IOException {
        if (trade.name == null) {
            return;
        }
        Ninja n = PlayerManager.getInstance().getNinja(trade.name);
        nj.type = 0;
        trade.close();
        trade.delay = 0;
        n.type = 0;
        n.p.trade.close();
        n.p.trade.delay = 0;
        Message m = new Message(57);
        m.writer().flush();
        conn.sendMessage(m);
        n.p.conn.sendMessage(m);
        m.cleanup();
    }

    public void viewPlayerMessage(Message m) throws IOException {
        String playername = m.reader().readUTF();
        m.cleanup();
        Ninja n = PlayerManager.getInstance().getNinja(playername);
        if (n == null) {
            sendAddchatYellow("Hiện tại người chơi đã offline");
            return;
        }
        if (n.id != nj.id) {
            n.p.sendAddchatYellow(nj.name + " đang đứng nhìn bạn");
        } else {
            loadSkill();
        }
        viewInfoPlayers(n.p);
    }

    public void viewInfoPlayers(Player p) throws IOException {
        Message m = new Message(93);
        m.writer().writeInt(p.nj.id);
        m.writer().writeUTF(p.nj.name);
        m.writer().writeShort(p.nj.partHead());
        m.writer().writeByte(p.nj.gender);//gioi tinh
        m.writer().writeByte(p.nj.nclass);//lop 0-->chua vao lop
        m.writer().writeByte(p.nj.pk);//diem hieu chien);
        m.writer().writeInt(p.nj.hp);
        m.writer().writeInt(p.nj.getMaxHP());
        m.writer().writeInt(p.nj.mp);
        m.writer().writeInt(p.nj.getMaxMP());
        m.writer().writeByte(p.nj.speed());//toc do
        m.writer().writeShort(p.nj.ResFire());//ResFire
        m.writer().writeShort(p.nj.ResIce());//ResIce
        m.writer().writeShort(p.nj.ResWind());//ResWind 
        m.writer().writeInt(p.nj.dameMax());//Dame
        m.writer().writeInt(p.nj.dameDown());//Dame down
        m.writer().writeShort(p.nj.Exactly());//Exactly
        m.writer().writeShort(p.nj.Miss());//Ne don
        m.writer().writeShort(p.nj.Fatal());//Fatal
        m.writer().writeShort(p.nj.ReactDame());//ReactDame
        m.writer().writeShort(p.nj.sysUp());//sysUp
        m.writer().writeShort(p.nj.sysDown());
        m.writer().writeByte(p.nj.level);
        m.writer().writeShort(38);//pointUydanh
        m.writer().writeUTF(p.nj.clanName);
        if (!p.nj.clanName.isEmpty()) {
            m.writer().writeByte(p.nj.typeclan);
        }
        m.writer().writeShort(39);
        m.writer().writeShort(40);
        m.writer().writeShort(41);
        m.writer().writeShort(42);
        m.writer().writeShort(43);
        m.writer().writeShort(44);
        m.writer().writeShort(45);
        m.writer().writeShort(46);
        m.writer().writeShort(47);
        m.writer().writeShort(48);
        m.writer().writeShort(49);
        m.writer().writeByte(50);
        m.writer().writeByte(51);
        m.writer().writeByte(52);
        m.writer().writeByte(53);
        m.writer().writeByte(54);
        for (Item body : p.nj.ItemBody) {
            if (body != null) {
                m.writer().writeShort(body.id);
                m.writer().writeByte(body.upgrade);
                m.writer().writeByte(body.sys);
            }
        }
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void endLoad(boolean canvas) throws IOException {
        Message m = new Message(126);
        m.writer().writeByte((canvas ? 0 : -1));
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }

    public void addFriend(Message m) throws IOException {
        String nF = m.reader().readUTF();
        m.cleanup();
        if (nF.equals(nj.name)) {
            sendAddchatYellow("Không thể thêm chính bản thân vào danh sách bạn bè.");
            return;
        }
        Player p = PlayerManager.getInstance().getNinja(nF).p;
        if (p == null) {
            sendAddchatYellow("Hiện tại người chơi này không online.");
            return;
        }
        JSONArray jar = (JSONArray) JSONValue.parse(nj.friend);
        JSONObject job = new JSONObject();
        for (Object jar1 : jar) {
            job = (JSONObject) jar1;
            if (nF.equals(job.get("name").toString())) {
                sendAddchatYellow(nF + " đã có tên trong danh sách bạn bè hoặc thù địch.");
                return;
            }
            job.clear();
        }
        boolean agree = false;
        JSONArray jarF = (JSONArray) JSONValue.parse(p.nj.friend);
        for (int i = 0; i < jarF.size(); i++) {
            JSONObject jobF = (JSONObject) jarF.get(i);
            if (jobF.get("name").toString().equals(nj.name)) {
                agree = true;
                jobF.put("agree", agree);
                jarF.set(i, jobF);
                p.nj.friend = jarF.toJSONString();
                break;
            }
        }
        job.put("name", nF);
        job.put("agree", agree);
        jar.add(job);
        nj.friend = jar.toJSONString();
        if (!agree) {
            m = new Message(59);
            m.writer().writeUTF(nj.name);
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
            sendAddchatYellow("Bạn đã thêm " + nF + " vào danh sách bạn bè.");
        } else {
            p.sendAddchatYellow(nj.name + " đã trở thành bạn bè hữu hảo.");
            sendAddchatYellow(nF + " đã trở thành bạn bè hữu hảo.");
        }
    }

    public void itemMonToBag(Message m) throws IOException {
        byte index = m.reader().readByte();
        m.cleanup();
        m = new Message(108);
        byte indexItemBag = nj.getIndexBagNotItem();
        nj.ItemBag[indexItemBag] = nj.ItemMounts[index];
        nj.ItemMounts[index] = null;
        m.writer().writeByte(nj.speed());
        m.writer().writeInt(nj.getMaxHP());
        m.writer().writeInt(nj.getMaxMP());
        m.writer().writeShort(0);
        m.writer().writeShort(0);
        m.writer().writeByte(index);
        m.writer().writeByte(indexItemBag);
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
        for (Player player : nj.place.players) {
            nj.place.sendMounts(this, player);
        }
    }

    protected void flush() {
        JSONArray jarr = new JSONArray();
        byte i = 0;
        try {
            if (nj != null) {
                nj.flush();
                String n = sortNinja[0];
                sortNinja[0] = nj.name;
                for (byte k = 1; k < sortNinja.length; k++) {
                    if (sortNinja[k] != null && sortNinja[k].equals(nj.name)) {
                        sortNinja[k] = n;
                    }
                }
            }
            //player
            for (byte k = 0; k < sortNinja.length; k++) {
                if (sortNinja[k] != null) {
                    jarr.add(sortNinja[k]);
                }
            }
            SQLManager.stat.executeUpdate("UPDATE `player` SET `luong`=" + luong + ",`ninja`='" + jarr.toJSONString() + "' WHERE `id`=" + id + " LIMIT 1;");
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    protected void close() {
    }

    public void openBookSkill(byte index, byte sid) throws IOException {
        if (nj.getSkill(sid) != null) {
            sendAddchatYellow("Bạn đã học kĩ năng này rồi");
            return;
        }
        nj.ItemBag[index] = null;
        Skill skill = new Skill();
        skill.id = sid;
        skill.point = 1;
        nj.skill.add(skill);
        viewInfoPlayers(this);
        loadSkill();
        Message m = new Message(-30);
        m.writer().writeByte(-102);
        m.writer().writeByte(index);
        m.writer().writeShort(SkillData.Templates(skill.id, skill.point).skillId);//id Skill
        m.writer().flush();
        conn.sendMessage(m);
        m.cleanup();
    }
    
    public  void  updateHP(int addHP) throws IOException{ 
       nj.hp += addHP;
        if(nj.hp <= 0)
            nj.hp = 0;
        else if(nj.hp < 10)
            nj.hp = 10;
        else if(nj.hp > nj.getMaxHP())
            nj.hp = nj.getMaxHP();
        addHP = (byte)(nj.hp*25/nj.getMaxHP());
        
   }
    
    public  void  updateMP(int addMP) throws IOException{ 
       nj.mp += addMP;
        if(nj.mp <= 0)
            nj.mp = 0;
        else if(nj.mp < 10)
            nj.mp = 10;
        else if(nj.mp > nj.getMaxMP())
            nj.mp = nj.getMaxMP();
        addMP = (byte)(nj.mp*20/nj.getMaxMP());
        
   }
    
    public void updateExp(long xpup) throws IOException {
        if (nj.exp > 10212000000000L) { //fix gioi han exp
            xpup = 10212000000000L - nj.exp;
        } else if (nj.exp < -10212000000000L) {
            xpup = -10212000000000L - nj.exp;
        }
        if (nj.expdown > 0) {
            nj.expdown -= xpup;
            Message m = new Message(71);
            m.writer().writeLong(xpup);//xpdown up
            m.writer().flush();
            conn.sendMessage(m);
            m.cleanup();
        } else {
            nj.expdown = 0L;
            nj.exp += xpup;
            int level = nj.level;
            nj.setLevel_Exp(nj.exp, true);
            if (level < nj.level) {
                if (nj.nclass != 0)
                    for (int i = level+1; i <= nj.level; i++) {
                        nj.ppoint += Level.getLevel(i).ppoint;
                        nj.spoint += Level.getLevel(i).spoint;
                    }
                else {
                    for (int i = level+1; i <= nj.level; i++) {
                        nj.potential0 += 5;
                        nj.potential1 += 2;
                        nj.potential2 += 2;
                        nj.potential3 += 2;
                    }
                }
            }
            Message m = new Message(5);
            m.writer().writeLong(xpup);//xp up
            m.writer().flush();
            conn.sendMessage(m);
            m.cleanup();
            if (level != nj.level)
                nj.setXPLoadSkill(nj.exp);
        }
    }

}
