package real;

import io.Message;
import io.Session;
import java.util.ArrayList;
import java.util.HashMap;

public class PlayerManager implements Runnable {
    protected PlayerManager() {
        new Thread(this).start();
    }

    protected static PlayerManager instance;

    public static PlayerManager getInstance() {
        if (instance == null)
            instance = new PlayerManager();
        return instance;
    }

    private boolean runing = true;
    
    private final ArrayList<Session> conns = new ArrayList<Session>();
    private final HashMap<Integer, Session> conns_id = new HashMap<>();

    private final HashMap<Integer, Player> players_id = new HashMap<Integer, Player>();
    private final HashMap<String, Player> players_uname = new HashMap<String, Player>();

    private final HashMap<Integer, Ninja> ninjas_id = new HashMap<Integer, Ninja>();
    private final HashMap<String, Ninja> ninjas_name = new HashMap<String, Ninja>();

    public void sendMessage(Message m) {
        synchronized (conns) {
            for (int i = conns.size()-1; i >= 0; i--)
                conns.get(i).sendMessage(m);
        }
    }
    
    public void NinjaMessage(Message m) {
        synchronized (conns) {
            for (int i = conns.size()-1; i >= 0; i--)
                if (conns.get(i).player != null && conns.get(i).player.nj != null)
                    conns.get(i).sendMessage(m);
        }
    }
    
    public void put(Session conn) {
        conns_id.put(conn.id, conn);
        conns.add(conn);
    }
    
    public void put(Player p) {
        players_id.put(p.id, p);
        players_uname.put(p.username, p);
    }
    
    public void put(Ninja n) {
        ninjas_id.put(n.id, n);
        ninjas_name.put(n.name, n);
    }
    
    private void remove(Session conn) {
        conns_id.remove(conn.id);
        conns.remove(conn);
        if (conn.player != null)
            remove(conn.player);
    }
    
    private void remove(Player p) {
        players_id.remove(p.id);
        players_uname.remove(p.username);
        if (p.nj != null)
            remove(p.nj);
        p.close();
        p.flush();
    }
    
    private void remove(Ninja n) {
        ninjas_id.remove(n.id);
        ninjas_name.remove(n.name);
        n.close();
        n.flush();
    }
    
    public Session getConn(int id) {
        return conns_id.get(id);
    }
    
    public Player getPlayer(int id) {
        return players_id.get(id);
    }
    
    public Player getPlayer(String uname) {
        return players_uname.get(uname);
    }
    
    public Ninja getNinja(int id) {
        return ninjas_id.get(id);
    }
    
    public Ninja getNinja(String name) {
        return ninjas_name.get(name);
    }

    public int conns_size() {
        return conns_id.size();
    }
    
    public int players_size() {
        return players_id.size();
    }
    
    public int ninja_size() {
        return ninjas_id.size();
    }

    private void kickSession(Session conn) {
        remove(conn);
        conn.disconnect();
    }
    
    public void Clear() {
        while(!conns.isEmpty())
            kickSession(conns.get(0));
    }
    
    private void update() {
        synchronized(conns) {
            for (int i = conns.size()-1; i >= 0; i--) {
                Session conn = conns.get(i);
                if (conn.outdelay > 0) {
                    conn.outdelay--;
                    if (conn.outdelay == 0) {
                        kickSession(conn);
                    }
                }
            }
        }
    }
    
    @Override
    public void run() {
        while (runing) {
            long l1 = System.currentTimeMillis();
            update();
            // Synchronize time
            long l2 = System.currentTimeMillis() - l1;
            if (l2 < 200)
                try {
                    Thread.sleep(200 - l2);
                } catch (InterruptedException e) {
                }
        }
    }
    
    public void close() {
        runing = false;
        instance = null;
    }
}
