package server;

import io.Message;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import real.Item;
import real.ItemData;
import real.Option;
import real.Player;
import real.ItemSell;

/**
 *
 * @author Văn Tú
 */
public class GameScr {

    static Server server = Server.getInstance();
    private static final short[] ArridLuck = new short[]{434,381,434,382,462,382,462,382,462,383,407,594,408,462,410,485,523,524,283,569};
    private static final byte[] ArrdayLuck = new byte[]{3, 7, 15, 30};
    private static final int[] ArryenLuck = new int[]{10000, 20000, 30000, 50000, 100000, 200000, 500000, 1000000, 5000000};

    
    public static byte SysClass(byte nclass) {
        if (nclass == 6 || nclass == 5)
            return 3;
        else if (nclass == 4 || nclass == 3)
            return 2;
        else if (nclass == 2 || nclass == 1)
            return 1;
        else
            return 0;
    }
        
    public static void sendSkill(Player p, Message m) throws IOException {
        String text = m.reader().readUTF();
        m.cleanup();
        byte[] arrSkill = null;
        int lent = 0;
        if (text.equals("OSkill")) {
            lent = p.nj.OSkill.length;
            arrSkill = new byte[lent];
            System.arraycopy(p.nj.OSkill, 0, arrSkill, 0, lent);
        }
        if (text.equals("CSkill")) {
            lent = 1;
            arrSkill = new byte[lent];
            arrSkill[0] = (byte) p.nj.CSkill;
        }
        if (arrSkill == null) {
            return;
        }
        m = new Message(-30);
        m.writer().writeByte(-65);
        m.writer().writeUTF(text);//pth
        m.writer().writeInt(lent);//size
        m.writer().write(arrSkill);//size
        m.writer().writeByte(0);//b8
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }

    public static void reciveImage(Player p, Message m) throws IOException {
        int id = m.reader().readInt();
        m.cleanup();
        byte[] data = loadFile("res/assets/icon/"+1+"/Small"+id+".png").toByteArray();
        m = new Message(-28);
        m.writer().writeByte(-115);
        m.writer().writeInt(id);
        m.writer().writeInt(data.length);
        m.writer().write(data);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
    
    public static ByteArrayOutputStream loadFile(String url) {
        FileInputStream openFileInput;
        try {
            openFileInput = new FileInputStream(url);
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            byte[] bArr = new byte[1024];
            while (true) {
                int read = openFileInput.read(bArr);
                if (read == -1) {
                    break;
                }
                byteArrayOutputStream.write(bArr, 0, read);
            }
            openFileInput.close();
            return byteArrayOutputStream;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static void saveFile(String url, byte[] data) {
        try {
            File f = new File(url);
            if (f.exists()) {
                f.delete();
            }
            f.createNewFile();
            FileOutputStream fos = new FileOutputStream(url);
            fos.write(data);
            fos.flush();
            fos.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void ItemInfo(Player p, Message m) throws IOException {
        byte type = m.reader().readByte();
        m.cleanup();
        util.Debug("Item info type "+type);
        Item[] arrItem = null;
        switch (type) {
            case 4:
                arrItem = p.nj.ItemBox;
                break;
            case 8:
                arrItem = ItemSell.SellItemType(type).item;
                break;
            case 9:
                arrItem = ItemSell.SellItemType(type).item;
                break;
            case 14:
                arrItem = ItemSell.SellItemType(type).item;
                break;
            case 15:
                arrItem = ItemSell.SellItemType(type).item;
                break;
            case 32:
                arrItem = ItemSell.SellItemType(type).item;
                break;
        }
        if (arrItem == null) {
            return;
        }
        if (type == 4) {
            m = new Message(31);
            m.writer().writeInt(p.nj.xuBox);//xu
            m.writer().writeByte(arrItem.length);//lent
            for (Item item : arrItem) {
                if (item != null) {
                    m.writer().writeShort(item.id);//id
                    m.writer().writeBoolean(item.isLock);//is lock
                    if (ItemData.isTypeBody(item.id) || ItemData.isTypeNgocKham(item.id)) {
                        m.writer().writeByte(item.upgrade);//id
                    }
                    m.writer().writeBoolean(item.isExpires);
                    m.writer().writeShort(item.quantity);
                } else {
                    m.writer().writeShort(-1);
                }
            }
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
        } else {
            m = new Message(33);
            m.writer().writeByte(type);//type
            m.writer().writeByte(arrItem.length);//lent
            for (int i = 0; i < arrItem.length; i++) {
                m.writer().writeByte(i);//index
                m.writer().writeShort(arrItem[i].id);//id
            }
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
        }
    }

    public static void buyItemStore(Player p, Message m) throws IOException {
        byte type = m.reader().readByte();
        byte index = m.reader().readByte();
        short num = 1;
        if (m.reader().available() > 0) {
            num = m.reader().readShort();
        }
        m.cleanup();
        Item sell = ItemSell.getItemTypeIndex(type, index);
        if (num <= 0 || sell == null) {
            return;
        }
        ItemData data = ItemData.ItemDataId(sell.id);
        if ((!data.uptoup && p.nj.getBagNull() >= num) || (data.uptoup && p.nj.getIndexBagid(sell.id, sell.isLock) != -1) || (data.uptoup && p.nj.getBagNull() > 0)) {
            if (p.nj.xu < sell.buyCoin * num) {
                p.conn.sendMessageLog("Không đủ xu");
                return;
            }
            if (p.nj.yen < sell.buyCoinLock * num) {
                p.conn.sendMessageLog("Không đủ yên");
                return;
            }
            if (p.luong < sell.buyGold * num) {
                p.conn.sendMessageLog("Không đủ lượng");
                return;
            }
            p.nj.upxu(-sell.buyCoin * num);
            p.nj.upyen(-sell.buyCoinLock * num);
            p.upluong(-sell.buyGold * num);
            for (int i = 0; i < num; i++) {
                Item item = new Item();
                item.id = sell.id;
                if (sell.isLock) {
                    item.isLock = true;
                }
                if (sell.isExpires) {
                    item.isExpires = true;
                    item.expires = util.TimeMillis(sell.expires);
                }
                item.saleCoinLock = sell.saleCoinLock;
                for (Option Option : sell.option) {
                    int idOp = Option.id;
                    int par = util.nextInt(ItemData.minParam(idOp, Option.param),Option.param);
                    Option option = new Option(idOp, par);
                    item.option.add(option);
                }
                if (data.uptoup) {
                    item.quantity = num;
                    p.nj.addItemBag(true, item);
                    break;
                } else {
                    p.nj.addItemBag(false, item);
                }
            }
            m = new Message(13);
            m.writer().writeInt(p.nj.xu);//xu
            m.writer().writeInt(p.nj.yen);//yen
            m.writer().writeInt(p.luong);//luong
            m.writer().flush();
            p.conn.sendMessage(m);
            m.cleanup();
        } else {
            p.conn.sendMessageLog("Hành trang không đủ chỗ trống");
        }
    }

    public static void LuckValue(Player p, Message m) throws IOException {
        byte index = m.reader().readByte();
        m.cleanup();
        if (index < 0 || index > 8) {
            index = 0;
        }
        if (p.nj.getBagNull() == 0) {
            p.conn.sendMessageLog("Hành trang không đủ chỗ trống.");
            return;
        } else if (p.nj.quantityItemyTotal(340) == 0) {
            p.conn.sendMessageLog("Cần có phiếu may mắn.");
            return;
        }
        p.nj.removeItemBags(340, 1);
        short id = ArridLuck[util.nextInt(ArridLuck.length)];
        Item item;
        ItemData data = ItemData.ItemDataId(id);
        if (data.type < 10) {
            if (data.type == 1) {
                item = ItemData.itemDefault(id);
                item.sys = GameScr.SysClass(data.nclass);
            } else {
                byte sys = (byte) util.nextInt(1,3);
                item = ItemData.itemDefault(id, sys);
            }
        } else
            item = ItemData.itemDefault(id);
        if (id == 523 || id == 419) {
            item.isExpires = true;
            item.expires = util.TimeDay(ArrdayLuck[util.nextInt(ArrdayLuck.length)]);
        }
        if (data.type != 19) {
            p.nj.addItemBag(true, item);
        } else {
            item.quantity = ArryenLuck[util.nextInt(ArryenLuck.length)];
            p.nj.upyenMessage(item.quantity);
            p.sendAddchatYellow("Bạn nhận được " + item.quantity + " yên");
        }
        if (item.quantity >= 500000) {
            server.manager.chatKTG(p.nj.name + " tham gia thẻ bài bí mật nhận được" + ((item.quantity > 1) ? " " + item.quantity + " " : " ") + data.name);
        }
        m = new Message(-28);
        m.writer().writeByte(-72);
        for (byte i = 0; i < 9; i++) {
            if (i == index) {
                m.writer().writeShort(id);
            } else {
                m.writer().writeShort(ArridLuck[util.nextInt(ArridLuck.length)]);
            }
        }
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }

}
