package server;

import io.Message;
import java.io.IOException;
import static java.lang.System.exit;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.HashMap;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.JSONValue;
import real.Item;
import real.ItemData;
import real.ItemSell;
import real.Level;
import real.Map;
import real.Npc;
import real.Option;
import real.Player;
import real.PlayerManager;
import real.SkillData;
import real.SkillTemplates;
import real.Vgo;

/**
 *
 * @author Văn Tú
 */
public class Manager {

    int post;
    private String host;
    private String mysql_host;
    private String mysql_database;
    private String mysql_user;
    private String mysql_pass;
    private byte vsData;
    private byte vsMap;
    private byte vsSkill;
    private byte vsItem;
    Server server = Server.getInstance();
    Rotationluck rotationluck[] = new Rotationluck[2];

    public String[] NinjaS = new String[]{"Chưa vào lớp", "Ninja Kiếm", "Ninja Phi Tiêu", "Ninja Kinai", "Ninja Cung", "Ninja Đao", "Ninja Quạt"};

    public Manager() {
        loadConfigFile();
        rotationluck[0] = new Rotationluck("Vòng xoay vip", (byte) 0, (short) 120, 1000000, 50000000, 1000000000);
        rotationluck[1] = new Rotationluck("Vòng xoay thường", (byte) 1, (short) 120, 10000, 100000, 500000000);
        rotationluck[0].start();
        rotationluck[1].start();
        loadDataBase();
    }

    public Map getMapid(int id) {
        for (Map map : server.map) {
            if (map.id == id) {
                return map;
            }
        }
        return null;
    }
    
    private void loadConfigFile() {
        byte[] ab = GameScr.loadFile("ninja.conf").toByteArray();
        if (ab == null) {
            System.out.println("Config file not found!");
            System.exit(0);
        }
        String data = new String(ab);
        HashMap<String, String> configMap = new HashMap<>();
        StringBuilder sbd = new StringBuilder();
        boolean bo = false;
        for (int i = 0; i <= data.length(); i++) {
            char es;
            if ((i == data.length()) || ((es = data.charAt(i)) == '\n')) {
                bo = false;
                String sbf = sbd.toString().trim();
                if (sbf != null && !sbf.equals("") && sbf.charAt(0) != '#') {
                    int j = sbf.indexOf(':');
                    if (j > 0) {
                        String key = sbf.substring(0, j).trim();
                        String value = sbf.substring(j + 1).trim();
                        configMap.put(key, value);
                        System.out.println("config: " + key + "-" + value);
                    }
                }
                sbd.setLength(0);
                continue;
            }
            if (es == '#') {
                bo = true;
            }
            if (!bo) {
                sbd.append(es);
            }
        }
        if (configMap.containsKey("debug")) {
            util.setDebug(Boolean.parseBoolean(configMap.get("debug")));
        } else {
            util.setDebug(false);
        }
        if (configMap.containsKey("host")) {
            host = configMap.get("host");
        } else {
            host = "localhost";
        }
        if (configMap.containsKey("post")) {
            post = Short.parseShort(configMap.get("post"));
        } else {
            post = 14444;
        }
        if (configMap.containsKey("mysql-host")) {
            mysql_host = configMap.get("mysql-host");
        } else {
            mysql_host = "localhost";
        }
        if (configMap.containsKey("mysql-user")) {
            mysql_user = configMap.get("mysql-user");
        } else {
            mysql_user = "root";
        }
        if (configMap.containsKey("mysql-password")) {
            mysql_pass = configMap.get("mysql-password");
        } else {
            mysql_pass = "";
        }
        if (configMap.containsKey("mysql-database")) {
            mysql_database = configMap.get("mysql-database");
        } else {
            mysql_database = "ninja";
        }
        if (configMap.containsKey("version-Data")) {
            vsData = Byte.parseByte(configMap.get("version-Data"));
        } else {
            vsData = 54;
        }
        if (configMap.containsKey("version-Map")) {
            vsMap = Byte.parseByte(configMap.get("version-Map"));
        } else {
            vsMap = 86;
        }
        if (configMap.containsKey("version-Skill")) {
            vsSkill = Byte.parseByte(configMap.get("version-Skill"));
        } else {
            vsSkill = 10;
        }
        if (configMap.containsKey("version-Item")) {
            vsItem = Byte.parseByte(configMap.get("version-Item"));
        } else {
            vsItem = 70;
        }
    }

    private void loadDataBase() {
        SQLManager.create(mysql_host, mysql_database, mysql_user, mysql_pass);
        int i = 0;
        ResultSet res;
        try {
            res = SQLManager.stat.executeQuery("SELECT * FROM `map`;");
            if (res.last()) {
                server.map = new Map[res.getRow()];
                res.beforeFirst();
            }
            while (res.next()) {
                server.map[i] = new Map((byte) res.getShort("id"), (byte) res.getByte("tile"), (byte) res.getByte("backid"), res.getString("name"), (byte) res.getByte("type"), res.getByte("maxplayer"), res.getByte("numzone"), res.getShort("x0"), res.getShort("y0"));
                JSONArray jarr = (JSONArray) JSONValue.parse(res.getString("Vgo"));
                server.map[i].vgo = new Vgo[jarr.size()];
                for (byte j = 0; j < jarr.size(); j++) {
                    server.map[i].vgo[j] = new Vgo();
                    JSONArray jar2 = (JSONArray) JSONValue.parse(jarr.get(j).toString());
                    Vgo vg = server.map[i].vgo[j];
                    vg.minX = Short.parseShort(jar2.get(0).toString());
                    vg.minY = Short.parseShort(jar2.get(1).toString());
                    vg.maxX = Short.parseShort(jar2.get(2).toString());
                    vg.maxY = Short.parseShort(jar2.get(3).toString());
                    vg.mapid = (byte) Short.parseShort(jar2.get(4).toString());
                    vg.goX = Short.parseShort(jar2.get(5).toString());
                    vg.goY = Short.parseShort(jar2.get(6).toString());
                }
                jarr = (JSONArray) JSONValue.parse(res.getString("NPC"));
                server.map[i].npc = new Npc[jarr.size()];
                for (byte j = 0; j < jarr.size(); j++) {
                    server.map[i].npc[j] = new Npc();
                    JSONArray jar2 = (JSONArray) JSONValue.parse(jarr.get(j).toString());
                    Npc npc = server.map[i].npc[j];
                    npc.type = Byte.parseByte(jar2.get(0).toString());
                    npc.x = Short.parseShort(jar2.get(1).toString());
                    npc.y = Short.parseShort(jar2.get(2).toString());
                    npc.id = Byte.parseByte(jar2.get(3).toString());
                }
                i++;
            }
            res.close();
            i = 0;
            res = SQLManager.stat.executeQuery("SELECT * FROM `item`;");
            while (res.next()) {
                ItemData item = new ItemData();
                item.id = Short.parseShort(res.getString("id"));
                item.type = Byte.parseByte(res.getString("type"));
                item.nclass = Byte.parseByte(res.getString("class"));
                item.skill = Byte.parseByte(res.getString("skill"));
                item.gender = Byte.parseByte(res.getString("gender"));
                item.name = res.getString("name");
                item.description = res.getString("description");
                item.level = Byte.parseByte(res.getString("level"));
                item.iconID = Short.parseShort(res.getString("iconID"));
                item.part = Short.parseShort(res.getString("part"));
                item.uptoup = Byte.parseByte(res.getString("uptoup")) == 1;
                item.isExpires = Byte.parseByte(res.getString("isExpires")) == 1;
                item.seconds_expires = Long.parseLong(res.getString("secondsExpires"));
                item.saleCoinLock = Integer.parseInt(res.getString("saleCoinLock"));
                item.itemoption = new ArrayList<>();
                JSONArray Option = (JSONArray) JSONValue.parse(res.getString("ItemOption"));
                for (int j = 0; j < Option.size(); j++) {
                    JSONObject job = (JSONObject) Option.get(j);
                    Option option = new Option(Integer.parseInt(job.get("id").toString()), Integer.parseInt(job.get("param").toString()));
                    item.itemoption.add(option);
                }
                ItemData.entrys.add(item);
                i++;
            }
            res.close();
            i = 0;
            res = SQLManager.stat.executeQuery("SELECT * FROM `skill`;");
            while (res.next()) {
                SkillData skill = new SkillData();
                skill.id = Short.parseShort(res.getString("id"));
                skill.nclass = Byte.parseByte(res.getString("class"));
                skill.name = res.getString("name");
                skill.maxPoint = Byte.parseByte(res.getString("maxPoint"));
                skill.type = Byte.parseByte(res.getString("type"));
                skill.iconId = Short.parseShort(res.getString("iconId"));
                skill.desc = res.getString("desc");
                JSONArray Skilltemplate = (JSONArray) JSONValue.parse(res.getString("SkillTemplates"));
                for (Object template : Skilltemplate) {
                    JSONObject job = (JSONObject) template;
                    SkillTemplates temp = new SkillTemplates();
                    temp.skillId = Short.parseShort(job.get("skillId").toString());
                    temp.point = Byte.parseByte(job.get("point").toString());
                    temp.level = Integer.parseInt(job.get("level").toString());
                    temp.manaUse = Short.parseShort(job.get("manaUse").toString());
                    temp.coolDown = Integer.parseInt(job.get("coolDown").toString());
                    temp.dx = Short.parseShort(job.get("dx").toString());
                    temp.dy = Short.parseShort(job.get("dy").toString());
                    temp.maxFight = Byte.parseByte(job.get("maxFight").toString());
                    JSONArray Option = (JSONArray) JSONValue.parse(job.get("options").toString());
                    for (Object option : Option) {
                        JSONObject job2 = (JSONObject) option;
                        Option op = new Option(Integer.parseInt(job2.get("id").toString()), Integer.parseInt(job2.get("param").toString()));
                        temp.options.add(op);
                    }
                    skill.templates.add(temp);
                }
                SkillData.entrys.add(skill);
                i++;
            }
            res.close();
            i = 0;
            res = SQLManager.stat.executeQuery("SELECT * FROM `ItemSell`;");
            while (res.next()) {
                ItemSell sell = new ItemSell();
                sell.id = Integer.parseInt(res.getString("id"));
                sell.type = Byte.parseByte(res.getString("type"));
                JSONArray jar = (JSONArray) JSONValue.parse(res.getString("ListItem"));
                if (jar != null) {
                    sell.item = new Item[jar.size()];
                    for (byte j = 0; j < jar.size(); j++) {
                        JSONObject job = (JSONObject) jar.get(j);
                        Item item = ItemData.parseItem(jar.get(j).toString());
                        item.buyCoin = Integer.parseInt(job.get("buyCoin").toString());
                        item.buyCoinLock = Integer.parseInt(job.get("buyCoinLock").toString());
                        item.buyGold = Integer.parseInt(job.get("buyGold").toString());
                        sell.item[j] = item;
                    }
                }
                ItemSell.entrys.add(sell);
                i++;
            }
            res.close();
            i = 0;
            res = SQLManager.stat.executeQuery("SELECT * FROM `level`;");
            while (res.next()) {
                Level level = new Level();
                level.level = Integer.parseInt(res.getString("level"));
                level.exps = Long.parseLong(res.getString("exps"));
                level.ppoint = Short.parseShort(res.getString("ppoint"));
                level.spoint = Short.parseShort(res.getString("spoint"));
                Level.entrys.add(level);
                i++;
            }
            res.close();
        } catch (Exception e) {
            System.out.println("Error i:" + i);
            e.printStackTrace();
            exit(0);
        }
    }
    
    public void getPackMessage(Player p) throws IOException {
        Message m = new Message(-28);
        m.writer().writeByte(-123);
        m.writer().writeByte(vsData);
        m.writer().writeByte(vsMap);
        m.writer().writeByte(vsSkill);
        m.writer().writeByte(vsItem);
        m.writer().writeByte(0);
        m.writer().writeByte(0);
        m.writer().writeByte(0);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
    public void sendData(Player p) throws IOException {
        Message m = new Message(-28);
        m.writer().writeByte(-122);
        m.writer().write(server.cache[0].toByteArray());
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
    public void sendMap(Player p) throws IOException {
        Message m = new Message(-28);
        m.writer().writeByte(-121);
        m.writer().write(server.cache[1].toByteArray());
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
    public void sendSkill(Player p) throws IOException {
        Message m = new Message(-28);
        m.writer().writeByte(-120);
        m.writer().write(server.cache[2].toByteArray());
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
    
    public void sendItem(Player p) throws IOException {
        Message m = new Message(-28);
        m.writer().writeByte(-119);
        m.writer().write(server.cache[3].toByteArray());
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
    
    public void chatKTG(String chat) throws IOException {
        Message m = new Message(-25);
        m.writer().writeUTF(chat);
        m.writer().flush();
        PlayerManager.getInstance().NinjaMessage(m);
        m.cleanup();
    }

    public void Infochat(String chat) throws IOException {
        Message m = new Message(-24);
        m.writer().writeUTF(chat);
        m.writer().flush();
        PlayerManager.getInstance().NinjaMessage(m);
        m.cleanup();
    }
    
    protected void stop() {
        
    }

    protected void chatKTG(Player p, Message m) throws IOException {
        String chat = m.reader().readUTF();
        m.cleanup();
        if (p.chatKTGdelay > System.currentTimeMillis()) {
            p.conn.sendMessageLog("Chờ sau " + ((p.chatKTGdelay - System.currentTimeMillis()) / 1000L) + "s.");
            return;
        }
        if (p.nj.name.equals("huong") && chat.equals("baotri")) {
            server.stop();
            return;
        }
        p.chatKTGdelay = System.currentTimeMillis() + 5000L;
        if (p.luong < 5) {
            p.conn.sendMessageLog("Bạn không có đủ lượng trên người.");
            return;
        }
        p.luongMessage(-5);
        m = new Message(-21);
        m.writer().writeUTF(p.nj.name);
        m.writer().writeUTF(chat);
        m.writer().flush();
        PlayerManager.getInstance().NinjaMessage(m);
        m.cleanup();
    }

    public void sendTB(Player p, String title, String s) throws IOException {
        Message m = new Message(53);
        m.writer().writeUTF(title);
        m.writer().writeUTF(s);
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }

    public void luck(Player p, Message m) throws IOException {
        short type = m.reader().readShort();
        String s = m.reader().readUTF();
        byte b = m.reader().readByte();
        m.cleanup();
        switch (type) {
            case 100:
                String num = s.replaceAll(" ", "").trim();
                if (num.length() > 10 || !util.checkNumInt(num) || b < 0 || b >= rotationluck.length) {
                    return;
                }
                int xujoin = Integer.parseInt(num);
                rotationluck[b].joinLuck(p, xujoin);
                break;
            case 101:
                if (b < 0 || b >= rotationluck.length) {
                    return;
                }
                rotationluck[b].luckMessage(p);
                break;
            case 102:
                p.typemenu = 92;
                server.menu.doMenuArray(p, new String[]{"Vòng xoay vip", "Vòng xoay thường"});
                break;
        }
    }

    protected void close() {
        for (int i = 0; i < rotationluck.length; i++) {
            rotationluck[i].close();
            rotationluck[i] = null;
        }
        rotationluck = null;
        for (int i = 0; i < server.map.length; i++) {
            server.map[i].close();
            server.map[i] = null;
        }
        server.map = null;
    }
}
