package server;

import io.ISessionHandler;
import io.Message;
import io.Session;
import real.Player;

public class SessionHandler implements ISessionHandler {

    Server server = Server.getInstance();

    @Override
    public void onConnectOK(Session conn) {

    }

    @Override
    public void onConnectionFail(Session conn) {

    }

    @Override
    public void onDisconnected(Session conn) {
        conn.outdelay = 5;
    }

    @Override
    public void processMessage(Session conn, Message message) {
        ServerController ctl = server.controllerManager;
        try {
            Player p = conn.player;
            switch (message.getCommand()) {
                case -30:
                    if (p != null) {
                        p.messageSubCommand(message);
                    }
                    break;
                case -29:
                    ctl.processGameMessage(conn, message);
                    break;
                case -28:
                    if (p != null) {
                        p.processGameMessage(message);
                    }
                    break;
                // Handsake
                case -27:
                    conn.hansakeMessage();
                    break;
                //Chat cong dong
                case -23:
                    if (p != null) {
                        p.nj.place.Chat(p, message);
                    }
                    break;
                //Chat rieng
                case -22:
                    if (p != null) {
                        p.privateChat(message);
                    }
                    break;
                //Chat Kenh The Gioi
                case -21:
                    if (p != null) {
                        server.manager.chatKTG(p, message);
                    }
                    break;
                //Next map
                case -17:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.VGo(p, message);
                    }
                //nhat vat pham
                case -14:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.pickItem(p, message);
                    }
                    break;
                //Bo item ra dat
                case -12:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.leaveItemBackground(p, message);
                    }
                    break;
                //Quay ve
                case -9:
                    if (p != null && p.nj.isDie) {
                        p.nj.place.DieReturn(p);
                    }
                    break;
                //Di chuyen
                case 1:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.moveMessage(p, message);
                    }
                    break;
                //Dung item
                case 11:
                    if (p != null && !p.nj.isDie) {
                        p.useItem(message);
                    }
                    break;
                //Mua item
                case 13:
                    if (p != null && !p.nj.isDie) {
                        GameScr.buyItemStore(p, message);
                    }
                    break;
                //Ban do
                case 14:
                    if (p != null) {
                        p.SellItemBag(message);
                    }
                    break;
                // cat trang bi
                case 15:
                    if (p != null) {
                        p.itemBodyToBag(message);
                    }
                    break;
                // Lay do trong ruong ra
                case 16:
                    if (p != null) {
                        p.itemBoxToBag(message);
                    }
                    break;
                // Cat do vo ruong
                case 17:
                    if (p != null) {
                        p.itemBagToBox(message);
                    }
                    break;
                //Chon khu vuc
                case 28:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.selectUIZone(p, message);
                    }
                    break;
                //send menu
                case 29:
                    if (p != null) {
                        server.menu.sendMenu(p, message);
                    }
                    break;
                //Mo doi khu vuc
                case 36:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.openUIZone(p);
                    }
                    break;
                //Mo npc
                case 40:
                    if (p != null && !p.nj.isDie) {
                        server.menu.openUINpc(p, message);
                    }
                    break;
                //Dung ki nang
                case 41:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.useSkill(p, message);
                    }
                    break;
                //Xem info item
                case 42:
                    if (p != null) {
                        p.requestItemInfo(message);
                    }
                    break;
                //Giao Dich
                case 43:
                    if (p != null && !p.nj.isDie) {
                        p.requestTrade(message);
                    }
                    break;
                //Bat dau giao dich
                case 44:
                    if (p != null && !p.nj.isDie) {
                        p.startTrade(message);
                    }
                    break;
                //Khoa giao dich
                case 45:
                    if (p != null) {
                        p.lockTrade(message);
                    }
                    break;
                //Dong y giao dich
                case 46:
                    if (p != null) {
                        p.agreeTrade();
                    }
                    break;
                //select menu npc
                case 47:
                    if (p != null) {
                        p.nj.place.selectMenuNpc(p, message);
                    }
                    break;
                //colse y giao dich
                case 56:
                    if (p != null) {
                        p.trade.close();
                    }
                    break;
                //Dong giao dich
                case 57:
                    if (p != null) {
                        p.closeTrade();
                    }
                    break;
                //Ket ban
                case 59:
                    if (p != null) {
                        p.addFriend(message);
                    }
                    break;
                //pk
                case 61:
                    if (p != null && !p.nj.isDie) {
                        p.nj.place.FightNinja(p, message);
                    }
                    break;
                // vxmm
                case 92:
                    if (p != null) {
                        server.manager.luck(p, message);
                    }
                    break;
                //view info players
                case 93:
                    if (p != null) {
                        p.viewPlayerMessage(message);
                    }
                    break;
                case 108:
                    if (p != null) {
                        p.itemMonToBag(message);
                    }
                    break;
            }
            message.cleanup();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
